#!/usr/local/bin/perl
################################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################
$SVERSION{'cartit_check_install.cgi'} = "8.0.07.377";
#All systems
$PASSFILE = '.pass';
if($^O eq 'MSWin32'){
$PASSFILE = 'my.pass';
	my $scriptname = $0;
	$scriptname =~ s/^(.*)[\/\\]([^\/\\]+)$/$2/;
	push(@INC,$1);
}

$require_failed = 1 unless eval 'require ("cartitcf.cgi");';


print "Content-type: text/html\n\n";



&print_top;

if ($require_failed){
	print "<CENTER><DIV ALIGN=\"CENTER\"><TABLE CELLPADDING=\"3\" CELLSPACING=\"3\" BORDER=\"0\" WIDTH=\"500\">\n";
	print "	<TR class=checkouttablebody>\n";
	print "<TD>\n";
	print "Failed to call the cartitcf.cgi file.  \n";
	print "Make sure you have entered your license number into this file and that this file was uploaded correctly!\n";
	print "</TD>\n";
	print "	</TR>\n";
	print "</TABLE>\n";
	print "</DIV></CENTER><p>\n";
}
else {
	&check_install;
}

&print_foot;

sub check_install{
	
	
	if(-e "$data_directory/$PASSFILE"){
		print "<CENTER><DIV ALIGN=\"CENTER\"><TABLE CELLPADDING=\"3\" CELLSPACING=\"3\" BORDER=\"0\" WIDTH=\"500\">\n";
		print "	<TR class=checkouttablebody>\n";
		print "<TD>\n";
		print "This script has already been run!\n";
		print "</TD>\n";
		print "	</TR>\n";
		print "</TABLE>\n";
		print "</DIV></CENTER><p>\n";
		return;
		
	}
	

	
	
	
		%DIRS =("$data_directory"=>'This directory must be created and CartIt must be able to read and write to it. This directory is where your configuration files are stored.',
	"$cart_directory"=>'This directory must be created and CartIt must be able to read and write to it. This is where your customers\' cart files are stored temporarily.');
	
	
	
		%FILES=('account.new' =>'This file must be uploaded as an empty file.',
		'neworder.txt' =>'This file must be uploaded as an empty file.',
		'neworder.dat'  =>'This file must be uploaded as an empty file.',
		'cartit_cb_invoice.html' => 'This file must be uploaded.',
		'cartit_shopping_cart_empty.html' =>'This file must be uploaded.',
		'yourpassword.txt' =>'This file must be uploaded.',
		'cartit_customer_invoice.html' =>'This file must be uploaded.',
		'cartit_invoice_notice.txt' => 'This file must be uploaded.',
		'shopper_banned.html' => 'This file must be uploaded.',
		'header_empty_but_saved.html' => 'This file must be uploaded.',
		
	'stylesheet.html' => 'This file must be uploaded.');
	
	
	
	
	
		%OPTIONFILES=('checkoutheader.html' => 'This file allows you to customize the header of the shopping cart.',
		'disclaimer.html' => 'This file allows you to have a document displayed in the final checkout process, commonly used for disclaimers and notices.',
		'footer.html' => 'This file allows you  to personalize the footer of the shopping cart.',
		'currency_options_header.html' => 'This file allows you  to personalize the header of the currency conversion options.',
		'currency_options_footer.html' => 'This file allows you  to personalize the footer of the currency conversion options.',
	'header.html' => 'This file allows you to personalize the header of the shopping cart.');
	
	
	
	foreach $thefile (sort keys %DIRS){
		if(!-d "$thefile"){
			&print_response('D',"$thefile","$DIRS{$thefile} <p> The location $thefile is the value you set in cartitcf.cgi. This path may be incorrect or you may have forgotten to create the directory.");
			$ERROR=1;
		}
		if(-d "$thefile" && ((!-r "$thefile")||(!-w "$thefile"))){
			&print_response('P',"$thefile","$DIRS{$thefile} <p> The location $thefile is the value you set in cartitcf.cgi. This path is correct but it is not writable by this script.");
			$ERROR=1;
		}
	}
	return()if($ERROR);
	

	
	foreach $thefile (sort keys %FILES){
		if(!-e "$data_directory/$thefile"){
			&print_response('F',"$data_directory/$thefile",$FILES{$thefile});
			$ERROR=1;
		}
		
	}
	
	return()if($ERROR);
	
	
	foreach $thefile (sort keys %FILES){
		if((!-r "$data_directory/$thefile")||(!-w "$data_directory/$thefile")){
			&print_response('P',"$data_directory/$thefile","See CartIt Web Site or User Manual");
			$ERROR=1;
		}
	}
	
	return()if($ERROR);
	
	
	&parse_form;
	if($WEBDAT{'command'} eq "runnumbers"){
		if(!&runnumbers){
			&show_fail;
			return;
		}
	}
	
	
	if(!-e "$data_directory/invoices.count"){
		&show_gen_numbers;
		return();
		
	}
	
	
	
	if(&create_pass){
		&show_success;
		}else{
		&show_fail;
	}
	
	
	
	
	
	foreach $thefile (sort keys %OPTIONFILES){
		if(!-e "$data_directory/$thefile"){
			&print_response('F',"$data_directory/$thefile","This is an <B>optional</B> customization file: $OPTIONFILES{$thefile}");
			$ERROR=1;
		}
	}
	
	
	
	
	
	
	
	
	
	
}

sub print_response{
	
	my($type, $file,$message) = @_;
	print "	<CENTER>";
	print "<TABLE CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"2\" WIDTH=\"500\" ><TR><TD ALIGN=\"CENTER\">\n";
	print "<TABLE WIDTH=\"100%\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\">\n";
	print "	<TR class=smallheading><TD COLSPAN=\"2\"><B>";
	
	if($type eq "P"){
		print "File permissions on \"$file\" are set incorrectly.";
		}elsif($type eq "D"){
		print "The directory \"$file\" does not exist.";
		}elsif($type eq "F"){
		print "The file \"$file\" does not exist.";
	}
	
	print "</B></TD></TR>\n";
	
	
	print "	<TR class=smallheading><TD COLSPAN=\"2\">ERROR DESCRIPTION</TD></TR>";
	print "	<TR class=checkouttablebody><TD COLSPAN=\"2\">";
	if($type eq "P"){
		print "	 The permission is  set incorrectly on \"$file\". I have attempted to read and write to \"$file\" and failed. This is caused\n";
		print "	 by not having the permission set correctly. The lowest possible permission you can use is chmod 777. This will make the file or directory fully \n";
		print "	 readable and writable by everyone and should solve the problem. You should consult your CartIt Commerce Developer for additional information about permissions.\n";
		}elsif($type eq "F"){
		print "The file \"$file\" does not exist. \"$file\" should have been included with your install package. You should\n";
		print " upload this file.\n";
		
		}elsif($type eq "D"){
		print "The directory \"$file\" does not exist. You need to create this directory or configure the location of the directory in cartitcf.cgi.\n";
		print " Note: The directory location shown above is the location you have set in cartitcf.cgi. If you are sure you have created the \"data\" and \"carts\" directories, then the location you have set in cartitcf.cgi may be invalid.";
		
	}
	print "</TD></TR>\n";
	print "	<TR class=smallheading><TD COLSPAN=\"2\">ADDITIONAL INFORMATION</TD></TR>";
	print "	<TR class=checkouttablebody><TD COLSPAN=\"2\">$message</TD></TR>\n";
	print "	</TABLE></TD></TR></TABLE></CENTER>	\n";
	print "	<p>\n";
	
}


sub print_top{
	print "<HTML><HEAD>\n";
	print "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n";
	print "<META NAME=\"generator\" CONTENT=\"CartIt DeveloperStudio Beta 1\">\n";
	print "<TITLE>Doing Install Check</TITLE>\n";
	
	print "<style>\n";
	print "<!--\n";
	print "P{font-family: Verdana, Arial, Helvetica;font-size:9pt}\n";
	print "TABLE{font-family: Verdana, Arial, Helvetica;font-size:9pt}\n";
	print "TD{font-family: Verdana, Arial, Helvetica;font-size:9pt}\n";
	print "TH{font-family: Verdana, Arial, Helvetica;font-size:9pt}\n";
	print "\n";
	print "\n";
	print ".smallheading{background-color:#C0C0C0}\n";
	print ".checkouttablebody{background-color:#EBEBEB}\n";
	print "\n";
	print "-->\n";
	print "</style>\n";
	
	
	print "</HEAD>\n";
	print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#FF0000\" VLINK=\"#000080\" ALINK=\"#800000\">\n";
	
	
}

sub print_foot{
	print "</BODY>\n";
	print "</HTML>\n";
}




sub create_pass{
	$WEBDAT{'newpass'} = 'cartit';
	$np = crypt($WEBDAT{'newpass'}, substr($WEBDAT{'newpass'}, 0, 2));
	$np = crypt($WEBDAT{'newpass'}, substr($np, 0, 2));
	open(PASSWD,">$data_directory/$PASSFILE") ||return();
	print PASSWD "$np";
	close(PASSWD);
	chmod(0777, "$data_directory/$PASSFILE");
	return(1);
	
	
	
}

sub show_success{
	
	
	print "<CENTER><DIV ALIGN=\"CENTER\"><TABLE CELLPADDING=\"10\" CELLSPACING=\"0\" BORDER=\"1\" WIDTH=\"500\">\n";
	print "	<TR class=checkouttablebody>\n";
	print "<TD>\n";
	print "<B>Congratulations!</B>\n";
	print "<P>\n";
	print "You have done a successful install. You should read this document in its entirety. For security reasons, this script will not function again. If you want to run this script again for any reason, you must delete the \"$PASSFILE\" file found in the data directory.<p>\n";
	print "<P>\n";
	print "The \"$PASSFILE\" file was just created by this script. It contains your encrypted connection password that you will use when connecting with CommerceBuddy. Your <B>current password is 'cartit'</B>, but you can change this with CommerceBuddy.\n";
	
	print "<P>\n";
	print "To access the CartIt system with CommerceBuddy, remember that your <B>current password is 'cartit'</B>, all lower case. You should change this password with CommerceBuddy as soon as possible. \n";
	print "<P>\n";
	print "If you do not have a copy of CommerceBuddy, you should download a copy from the CartIt web site. If you already have CommerceBuddy, you should never reinstall the program, as this will overwrite your database fields in the current version.\n";
	
	print "<p><B>Important:</B><BR>In order to use CartIt, you must be sure that you have connected to the web site with CommerceBuddy and updated your configurations.";
	print "CartIt will report a System Busy error message until you have done this.";
	
	print "<p><B>Your Install Should Be Complete</B><BR>";
	print "	We say <I>should</I> be complete because it is possible that you do not have the correct installation set up on CartIt.\n";
	print "	You can go directly to the CartIt URL as you have it configured in CommerceBuddy  and see if you get a System Busy error message.\n";
	print "	If you get a System Busy error message, this is good. It means that CartIt is functioning. The busy message will go away when you use CommerceBuddy to update you configurations.\n";
	print "	<p><B>If you get a <U>server</U> error:</B>\n";
	print "	<UL>\n";
	print "	<LI>You may have the path to PERL incorrectly configured in one or more of the CartIt scripts.\n";
	print "	<p><LI>You may have uploaded one or more of the scripts in binary mode.\n";
	print "	<p><LI>If you get a Forbidden message, you may not have the scripts set to chmod 755 (executable).\n";
	print "	<p><LI>If you are getting a 404 Not Found message, you may have the incorrect location to CartIt set in cartitcf.cgi.\n";
	print "	</UL>\n";
	print "	Note: Below you <I>may</I> find additional errors, if you see errors reported they \n";
	print "	are <B>not</B> vital errors, they are all errors regarding <I>optional</I> installation files\n";
	print "</TD>\n";
	print "	</TR>\n";
	print "</TABLE>\n";
	print "</DIV></CENTER><p>\n";
}

sub show_fail{
	print "<TABLE CELLPADDING=\"3\" CELLSPACING=\"0\" BORDER=\"0\" WIDTH=\"500\">\n";
	print "<TR class=checkouttablebody><TD>\n";
	print "I could not write to the data directory, you may need to chmod 777 the data directory.\n";
	print "</TD></TR></TABLE>\n";
	return();
}

sub show_gen_numbers{
	
	
	print "<CENTER><DIV ALIGN=\"CENTER\"><TABLE WIDTH=\"500\" CELLPADDING=\"5\" CELLSPACING=\"0\" BORDER=\"0\">\n";
	print "<TR class=checkouttablebody><TD COLSPAN=\"2\">\n";
	print "CartIt needs to know what invoice number (order number) and shopper account number \n";
	print "you want to start with.\n";
	print "<FORM ACTION=\"$ENV{'SCRIPT_NAME'}\" METHOD=\"POST\">\n";
	print "</TD></TR>\n";
	print "<TR class=checkouttablebody><TD COLSPAN=\"2\"><HR SIZE=\"1\" ALIGN=\"CENTER\" WIDTH=\"100%\"></TD></TR>\n";
	print "<TR class=checkouttablebody><TD>Starting <B>Invoice</B> Number</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"invoicenum\" VALUE=\"1001\" SIZE=\"6\" MAXLENGTH=\"6\"></TD></TR>\n";
	print "<TR class=checkouttablebody><TD>Starting <B>Account</B> Number</TD><TD><INPUT TYPE=\"TEXT\" NAME=\"accountnum\" VALUE=\"1001\" SIZE=\"6\" MAXLENGTH=\"6\"></TD></TR>\n";
	print "\n";
	print "<TR class=checkouttablebody><TD COLSPAN=\"2\"><HR SIZE=\"1\" ALIGN=\"CENTER\" WIDTH=\"100%\"></TD></TR>\n";
	print "\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"command\" VALUE=\"runnumbers\">\n";
	print "<TR class=checkouttablebody><TD COLSPAN=\"2\"><P>\n";
	print "&nbsp;You must enter the starting numbers now, but it is extremely important that you <U>NEVER CHANGE THESE NUMBERS AFTER THEY HAVE BEEN CREATED</U>.<P>\n";
	print "These numbers must remain unique for each order and account. CommerceBuddy will use these numbers for internal record referencing and modifying these numbers may cause data integrity errors.</TD></TR>\n";
	print "\n";
	print "<TR class=checkouttablebody><TD COLSPAN=\"2\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Create Starting Numbers\">Only Click Once!\n";
	print "</TD></TR>\n";
	print "</FORM>\n";
	print "</TABLE></DIV></CENTER>\n";
	
	
}




sub runnumbers{
	$WEBDAT{'accountnum'} =~ s/\D//g;
	$WEBDAT{'invoicenum'} =~ s/\D//g;
	return() if(($WEBDAT{'accountnum'} eq "") ||  ($WEBDAT{'invoicenum'} eq ""));
	
	open (FILE, ">$data_directory/invoices.count") || return();
	print FILE  "$WEBDAT{'invoicenum'}\n";
	chmod(0777, "$data_directory/invoices.count");
	close(FILE);
	
	open (FILE, ">$data_directory/accounts.count") || return();
	print FILE  "$WEBDAT{'accountnum'}\n";
	chmod(0777, "$data_directory/accounts.count");
	close(FILE);
	return(1);
	
}


sub parse_form{
	
	if ($ENV{'REQUEST_METHOD'} eq 'GET') {
		@pairs = split(/&/, $ENV{'QUERY_STRING'});
		
		}else{
		
		($ENV{'REQUEST_METHOD'} eq 'POST');
		if($ENV{'CONTENT_LENGTH'}>18000){&error('Too much information was sent to the server.');}
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
		
		@pairs = split(/&/, $buffer);
	}
	
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ge;
		$value =~ s/[\|`;]//g;
		$value=~ s/^\s+//g;
		$value =~ s/<!--(.|\n)*-->//g;
		$value =~ s/<([^>]|\n)*>//g;
		$value =~ s/"/&quot;/g;
		$WEBDAT{$name} = $value;
	}
	
}



sub xmodfailed{
	my $xmodule = shift;
	my $ret = shift;
	print qq[
	<html><head>
	<title>Error</title>
	</head>
	<body bgcolor="#FFFFFF" text="#000000" link="#0000FF" vlink="#FF0000" alink="#808080">
	
	<div align="center"><table cellpadding="3" cellspacing="3" border="0" width="500">
	<tr>
	<td>
	
	<font face="Verdana, Arial, Helvetica">
	A PERL module used by CartIt is not installed on the server. You must contact your Internet provider or CartIt commerce developer and ask them to install the following PERL module:
	</font>
	<p>
	<tt>&quot;$xmodule&quot;</tt><p>
	<font face="Verdana, Arial, Helvetica"><b>Exact Error was:</b></font>
	<p>
	<tt>$ret</tt>
	
<p>
	<font face="Verdana, Arial, Helvetica">
<b>Please note the CartIt requires the following modules as stated in the system requirements page.</b></font>
<pre>
LWP::UserAgent;
XML::DOM;
Crypt::SSLeay;
</pre>
	</td>
	</tr>
	</table></div>
	</body>
	</html>
	
	
	];
	exit;
	
}



