#!/usr/local/bin/perl
###############################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################
$SVERSION{'cartit_checkout.cgi'} = "8.0.07.377";
#All systems
if($^O eq 'MSWin32'){
	my $scriptname = $0;
	$scriptname =~ s/^(.*)[\/\\]([^\/\\]+)$/$2/;
	push(@INC,$1);
}
require ('cartitcf.cgi');
require ('cartitlib.cgi');
require ('cartitshiplib.cgi');
require ('cartitcclib.cgi');
require ('cartitimg.util');

$MODERROR{'LWP::UserAgent'} =1 unless eval 'require LWP::UserAgent;';
$MODERROR{'Crypt::SSLeay'}=1 unless eval 'require Crypt::SSLeay;';


################################################################
# The Affiliate module must be installed for this to work.
# If you have the affiliate module uncomment the "require"
# statement below.
################################################################
# require 'cartitaffiliate.cgi';
################################################################

$|=1;
if(-e "$data_directory/manager.lock"){
	&print_http_header;
	&system_busy;
}

&get_configs;

&about_cartit if($ENV{'QUERY_STRING'} eq "about");

&parse_form;
&get_cart_id;
&shopper_ban_message if(&shopper_banned);
&set_cookie('cid',"$cart_ID",25,'hours');
&set_cookie('shopping_id',"$cart_ID",0,'session');

$WEBDAT{'command'}='checkout' if($WEBDAT{'command'} eq '');
$WEBDAT{'ssl'}=1 if($ENV{'SERVER_PORT'} eq '443');

$ssl_file_txt = 'ssl' if($WEBDAT{'ssl'}==1);
if(&check_mods){
	&ModError_Header if (($USERCONFIGS{'cc_rtime'} && ($MODERROR{'Crypt::SSLeay'} || $MODERROR{'LWP::UserAgent'})) || ($USERCONFIGS{'shipping_method'}  eq 'livemethods' && ($MODERROR{'Crypt::SSLeay'} || $MODERROR{'LWP::UserAgent'} || $MODERROR{'XML::DOM'})));
	if($USERCONFIGS{'cc_rtime'} && ($MODERROR{'Crypt::SSLeay'} || $MODERROR{'LWP::UserAgent'})){
		print qq[
		<tr><td valign="top">Modules needed for real-time credit card processing were not found. </td>
		<td valign="top">Do not use real-time background credit card processing, at the very least, turn off real-time credit card processing until you can have these modules installed.</td>
		
		<td valign="top">Install the necessary PERL Modules, see below.</td>
		</tr>
		];
	}
	
	if($USERCONFIGS{'shipping_method'}  eq 'livemethods' && ($MODERROR{'Crypt::SSLeay'} || $MODERROR{'LWP::UserAgent'} || $MODERROR{'XML::DOM'})){
		print qq[
		
		<tr><td valign="top">Modules needed for live shipping connection were not found. </td>
		<td valign="top">Do not use a live connectivity shipping method, at the very least, turn off live connectivity shipping until you can have these modules installed.</</td>
		
		<td valign="top">Install the necessary PERL Modules, see below.</td>
		</tr>
		
		];
	}
	&ModError_Footer if (($USERCONFIGS{'cc_rtime'} && ($MODERROR{'Crypt::SSLeay'} || $MODERROR{'LWP::UserAgent'})) || ($USERCONFIGS{'shipping_method'}  eq 'livemethods' && ($MODERROR{'Crypt::SSLeay'} || $MODERROR{'LWP::UserAgent'} || $MODERROR{'XML::DOM'})));
}


&jamsession;


sub jamsession{
	
	
		if($WEBDAT{'command'} eq 'newaccount'){&newaccount;
		}elsif($WEBDAT{'command'} eq 'postnewaccount'){&post_new_account;
		}elsif($WEBDAT{'command'} eq 'checkout'){&checkout;
		}elsif($WEBDAT{'command'} eq 'myaccount'){&myaccount;
		}elsif($WEBDAT{'command'} eq 'queryaccount'){&queryaccount;
		}elsif($WEBDAT{'command'} eq 'show_confirm_screen'){&show_confirm_screen;
		}elsif($WEBDAT{'command'} eq 'modify_account'){&modify_account;
		}elsif($WEBDAT{'command'} eq 'show_invoice'){&show_invoice;
		}elsif($WEBDAT{'command'} eq 'do_mailittome'){&do_mailittome;
		}elsif($WEBDAT{'command'} eq 'mail_it_to_me'){&show_mail_it_to_me;
		}elsif($WEBDAT{'command'} eq 'intlogin'){&intlogin;
		}elsif($WEBDAT{'command'} eq 'manageit'){&manageit;
		
		
		
		
		
		
	}
	
	
	
}


# ------------------------------------------------------------------------------------
sub checkout{
	if(!$dual_checkout) {
	&print_document_top('Account Sign In');
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
	}
	
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ao\" VALUE=\"$WEBDAT{'ao'}\">\n";
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "<TABLE WIDTH=\"550\" CELLPADDING=\"4\" CELLSPACING=\"0\" BORDER=\"0\">\n";
	print "<TR class=\"heading\"><TD COLSPAN=\"2\">Account Sign In / Creation</TD></TR>\n";
	print "<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">";
	
	print "$LOGIN_ERROR<p>Please enter your e-mail address.\n";
	
	print "</TD></TR>\n";
	print "<TR class=\"checkouttablebody\"><TD><b>E-mail Address:</b><br>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"email\" VALUE=\"$CARTITSESSION{'email'}\" SIZE=\"30\" MAXLENGTH=\"250\"> </TD><TD ALIGN=\"CENTER\"></TD></TR>\n";
	
	print '<tr><td colspan="2">';
	
	print '<table cellpadding="3" cellspacing="2" border="0">';
	print '<tr><td width="10" valign="TOP"><input type="RADIO" name="passmethod" value="0"></td>';
	print '<td><b>I am a new customer.</b><br>';
	print '<i>You will create a password later.</i></td></tr>';
	
	
	print '<tr><td colspan="2" align="center"><b>OR</b></td></tr>';
	print '<tr><td width="10" valign="TOP"><input type="RADIO" name="passmethod" value="1" checked></td>';
	print '<td><b>I am a returning customer,<br>';
	print 'and my password is: </b><br>';
	print '<input type="PASSWORD" name="pass" size="10" maxlength="20"></td></tr>';
	
	
	print '</table>';
	print '</td></tr>';
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"intlogin\">\n";
	print "<tr><td colspan=\"3\"><INPUT TYPE=\"submit\" VALUE=\"Proceed\"></td></tr>\n";
	
	
	
	
	
	
	print "</TABLE></FORM>\n";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print "</FORM>\n";
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
	}else {
	&print_document_top('Account Sign In');
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');

	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);

	print "<TABLE WIDTH=\"550\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\">\n";
	print "<TR><TD WIDTH=\"100%\" COLSPAN=\"3\">$LOGIN_ERROR</TD></TR>\n";
	print "<TR><TD WIDTH=\"49%\" ALIGN=\"CENTER\" VALIGN=\"TOP\">\n";
	print "<TABLE WIDTH=\"100%\" CELLPADDING=\"4\" CELLSPACING=\"0\" BORDER=\"0\">\n";


	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
	}
	
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ao\" VALUE=\"$WEBDAT{'ao'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"passmethod\" VALUE=\"1\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"intlogin\">\n";


	print "<TR class=\"heading\" ALIGN=\"CENTER\"><TD>Existing Account Sign In</TD></TR>\n";
	print "<TR class=\"checkouttablebody\"><TD><b>E-mail Address:</b><BR><INPUT TYPE=\"TEXT\" NAME=\"email\" VALUE=\"$CARTITSESSION{'email'}\" SIZE=\"30\" MAXLENGTH=\"250\"></TD></TR>\n";
	print "<tr class=\"checkouttablebody\"><td><b>My password is:</b><BR><input type=\"PASSWORD\" name=\"pass\" size=\"30\" maxlength=\"20\"></td></tr>\n";
	print "<TR class=\"checkouttablebody\"><td ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"Proceed\"></td></TR>\n";
	print "</form></TABLE></TD>\n";
	print "<TD WIDTH=\"2%\">&nbsp;</td>\n";
	print "<TD WIDTH=\"49%\" ALIGN=\"CENTER\" VALIGN=\"TOP\">\n";

	print "<TABLE WIDTH=\"100%\" CELLPADDING=\"4\" CELLSPACING=\"0\" BORDER=\"0\">\n";

	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
	}
	
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ao\" VALUE=\"$WEBDAT{'ao'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"passmethod\" VALUE=\"0\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"intlogin\">\n";

	print "<TR class=\"heading\" ALIGN=\"CENTER\"><TD>New Account Sign Up</TD></TR>\n";
	print "<TR class=\"checkouttablebody\"><TD><b>E-mail Address:</b><BR><INPUT TYPE=\"TEXT\" NAME=\"email\" VALUE=\"\" SIZE=\"30\" MAXLENGTH=\"250\"></TD></TR>\n";
	print "<TR class=\"checkouttablebody\"><td ALIGN=\"CENTER\"><INPUT TYPE=\"submit\" VALUE=\"Proceed\"></td></TR>\n";

	print "</form></TABLE>\n";
	print "</TD></TR></TABLE>\n";

	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
	}

}




# ------------------------------------------------------------------------------------
sub myaccount{
	$WEBDAT{'ao'}=1;
	&checkout;
}



# ------------------------------------------------------------------------------------
sub queryaccount{
	&set_cart_status;
	my(@RECORD);
	my($t,%TAXES,$tline,$string,$carttotal,%SHIPIT,%TAXES,$methods);
	if($WEBDAT{'email'} eq ""){
		&errorform('You did not enter an e-mail address.');
		}elsif($WEBDAT{'pass'} eq ""){
		&errorform('You did not enter a password.');
	}
	my(@TAXES) = &get_taxes;
	my($account)=&get_account;
	if(!$account){
		&show_mail_it_to_me;
	}
	
	
	&print_document_top('Checkout Stand');
	
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
	
	
	print &show_cartit(0);
	
	($carttotal) = &get_cart_total;
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "	<TABLE WIDTH=\"500\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\">\n";
	print "	<TR>\n";
	print "	<TD>	\n";
	
	
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "	<TABLE CELLPADDING=\"7\" CELLSPACING=\"0\" BORDER=\"0\" WIDTH=\"100%\">\n";
	
	
	
	&show_standard_account_profile(1);
	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
	}
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ao\" VALUE=\"$WEBDAT{'ao'}\">\n";
	
	print "	<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"show_confirm_screen\">\n";
	print "	<INPUT TYPE=\"HIDDEN\" NAME=\"email\" VALUE=\"$WEBDAT{'email'}\">\n";
	print "	<INPUT TYPE=\"HIDDEN\" NAME=\"pass\" VALUE=\"$WEBDAT{'pass'}\">	\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
	
	
	
	
	
	
	if($USERCONFIGS{'use_coupons'} == 1){
		
		print "	<TR class=smallheading>\n";
		print "	<TD colspan=\"2\">\n";
		print "Do you have a coupon?\n";
		print "</TD></TR>\n";
		
		print "	<TR class=\"checkouttablebody\">\n";
		print "	<TD colspan=\"2\">\n";
		print "If you have a coupon, please enter the coupon code below.<BR>\n";
		print "	<TABLE WIDTH=\"250\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\" class=\"checkouttablebody\">\n";
		print "<TR class=\"checkouttablebody\"><TD>\n";
		print "Coupon Code\n";
		print "</TD>\n";
		print "<TD>\n";
		print "<INPUT TYPE=\"text\" NAME=\"coupon\" SIZE=\"10\" MAXLENGTH=\"10\" VALUE=\"$WEBDAT{'coupon'}\">\n";
		print "</TD>\n";
		print "	</TR>\n";
		print "	</TABLE>\n";
		
		print "</TD>\n";
		print "	</TR>\n";
		
	}
	
	
	
	
	print "	<TR class=\"smallheading\">\n";
	print "	<TD colspan=\"2\">\n";
	print "Please select one of the following payment options:\n";
	print "</TD></TR>\n";
	print "$ERROR{'pay_method'}";
	print "<TR class=\"checkouttablebody\"><TD colspan=\"2\">";
	print "	<TABLE WIDTH=\"100%\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\">\n";
	
	$DCHECK_TEST{$WEBDAT{'method'}} = ' CHECKED' if($WEBDAT{'method'});
	if($USERCONFIGS{'accept_cc'} == 1 && $USERCONFIGS{'remote_cc'} == 1){
		print "<TR class=\"checkouttablebody\"><TD><INPUT TYPE=\"RADIO\" NAME=\"method\" VALUE=\"5\" $DCHECK_TEST{'5'}></TD><TD>$USERCUSTOM{'REMOTE_SSL_DISPLAY_TEXT'}</TD></TR>\n";
	}
	
	$DCHECK_TEST{'1'} = ' CHECKED' if(!$WEBDAT{'method'});
	if($USERCONFIGS{'accept_cc'} == 1 && $USERCONFIGS{'remote_cc'} != 1){
		print "<TR class=\"checkouttablebody\"><TD><INPUT TYPE=\"RADIO\" NAME=\"method\" VALUE=\"1\" $DCHECK_TEST{'1'}></TD><TD>Credit Card</TD></TR>\n";
	}
	
	if($USERCONFIGS{'accept_cc_phone'} == 1 && $USERCONFIGS{'accept_cc'} == 1){
		print "<TR class=\"checkouttablebody\"><TD><INPUT TYPE=\"RADIO\" NAME=\"method\" VALUE=\"2\" $DCHECK_TEST{'2'}></TD><TD>Credit Card (Phone)</TD></TR>\n";
		
	}
	
	if($USERCONFIGS{'accept_cod'} == 1){
		print "	<TR class=\"checkouttablebody\"><TD><INPUT TYPE=\"RADIO\" NAME=\"method\" VALUE=\"3\" $DCHECK_TEST{'3'}></TD>\n";
		print "<TD>C.O.D. (<B>Cashiers check or money order only</B>) Add $USERCONFIGS{'money_sign'}$USERCONFIGS{'codfee'}</TD></TR>\n";
	}
	
	if($USERCONFIGS{'accept_pos'} == 1){
		print "<TR class=\"checkouttablebody\"><TD><INPUT TYPE=\"RADIO\" NAME=\"method\" VALUE=\"4\" $DCHECK_TEST{'4'}></TD><TD>Purchase Order Number</TD></TR>\n";
	}
	
	if($USERCONFIGS{'accept_mailchecks'} == 1){
		print "<TR class=\"checkouttablebody\"><TD><INPUT TYPE=\"RADIO\" NAME=\"method\" VALUE=\"6\" $DCHECK_TEST{'6'}></TD><TD>Mail your payment to us</TD></TR>\n";
	}
	
	
	print "	</TABLE>\n";
	print "	</TD>\n";
	print "	</TR>\n";
	
	
	&getshipping;
	
	
	
	
	
	
	
	
	
	
	if(@TAXES){
		if($ISLOGIC_TAXES==1){
			my $ziptax = $WEBDAT{'zip2'};
			$ziptax =~ s/ //g;
			for($i=0;$i<@TAXES;$i++){
					if($TAXES[$i][0] eq "##$WEBDAT{'state2'}"){# Can Also Be: || state
					print "<INPUT NAME=\"checkout_taxes\"TYPE=\"HIDDEN\" VALUE=\"$TAXES[$i][0]^$TAXES[$i][1]^$TAXES[$i][2]^$TAXES[$i][3]^$TAXES[$i][4]\">";
					}elsif($TAXES[$i][0] eq "#!$WEBDAT{'country2'}"){# Can Also Be: || Country
					print "<INPUT NAME=\"checkout_taxes\"TYPE=\"HIDDEN\" VALUE=\"$TAXES[$i][0]^$TAXES[$i][1]^$TAXES[$i][2]^$TAXES[$i][3]^$TAXES[$i][4]\">";
					}elsif($TAXES[$i][0] eq "#!$ziptax"){# Can Also Be: || Country
					print "<INPUT NAME=\"checkout_taxes\"TYPE=\"HIDDEN\" VALUE=\"$TAXES[$i][0]^$TAXES[$i][1]^$TAXES[$i][2]^$TAXES[$i][3]^$TAXES[$i][4]\">";
					
				}
			}
			
			}else{
			
			print "<TR class=smallheading>\n";
			print "<TD colspan=\"2\">$USERCUSTOM{'TAXES_HEADER'}</TD>\n";
			print "</TR>\n";
			
			
			print "<TR class=\"checkouttablebody\">\n";
			print "<TD colspan=\"2\">";
			print "$USERCUSTOM{'TAXES_TEXT_DESCRIPTION'}</TD>\n";
			print "</TR>\n";
			
			print "<TR class=\"checkouttablebody\">\n";
			print "<TD colspan=\"2\">";
			
			print "<TABLE BORDER=\"0\" CELLPADDING=\"3\" CELLSPACING=\"0\" class=\"checkouttablebody\">\n";
			
			
			
			if(!$USERCONFIGS{'taxes_as_select'}){
				for($i=0;$i<@TAXES;$i++){
					
					print "	<TR class=\"checkouttablebody\"><TD WIDTH=\"20\"><INPUT TYPE=\"CHECKBOX\" NAME=\"checkout_taxes\" VALUE=\"$TAXES[$i][0]^$TAXES[$i][1]^$TAXES[$i][2]^$TAXES[$i][3]^$TAXES[$i][4]\">";
					print "</TD><TD>$TAXES[$i][1]</TD></TR>\n";
				}
				
				}else{
				
				print "<TR class=\"checkouttablebody\"><TD><SELECT NAME=\"checkout_taxes\">\n";
				print "<OPTION  VALUE=\"\">None</OPTION>";
				
				
				for($i=0;$i<@TAXES;$i++){
					print "<OPTION VALUE=\"$TAXES[$i][0]^$TAXES[$i][1]^$TAXES[$i][2]^$TAXES[$i][3]^$TAXES[$i][4]\">";
					
					print "$TAXES[$i][1]</OPTION>\n";
					
				}
				
				print "</SELECT></TD></TR>\n";
				
				
				
			}
			
			print "</TABLE></TD></TR><P>\n";
			
		}
	}
	
	
	print "<TR class=\"checkouttablebody\"><TD colspan=\"2\">\n";
	
	print "	<INPUT TYPE=\"submit\" VALUE=\"Proceed\">\n";
	print "	</FORM>\n";
	print "	\n";
	print "	</TD>\n";
	print "	</TR>\n";
	print "	\n";
	print "	</TABLE>\n";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print "	</TD>\n";
	print "	</TR>\n";
	print "	</TABLE>\n";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
	
}




# ------------------------------------------------------------------------------------
sub post_new_account{
	my($from_existing_data) = shift;
	my($line,$f);
	&check_user_data;
	
	&errorform('You did not enter a password.')if($WEBDAT{'pass'} eq "");
	&errorform('Password must be letters and numbers only.')if($WEBDAT{'pass'} =~/[\W]/);
	
	
	
	if(!$from_existing_data){
		&errorform('The passwords you entered did not match.')if($WEBDAT{'pass'} ne  $WEBDAT{'pass2'});
	}
	
	
	
	
	
	if($WEBDAT{'sameasbilling'} eq "1"){
		$WEBDAT{'businessname2'} =$WEBDAT{'businessname'};
		$WEBDAT{'receiveby'} = $WEBDAT{'nameoncard'};
		$WEBDAT{'street2'} = $WEBDAT{'street'}	;
		$WEBDAT{'city2'} = $WEBDAT{'city'};
		$WEBDAT{'state2'} = $WEBDAT{'state'};
		$WEBDAT{'zip2'}	 = $WEBDAT{'zip'}	;
		$WEBDAT{'country2'} = $WEBDAT{'country'};
		$WEBDAT{'phone2'} = $WEBDAT{'phone'};
		
	}
	
	$line = $WEBDAT{'pass'} . '|' . $WEBDAT{'email'} .'|'. $WEBDAT{'businessname'} . '|' . $WEBDAT{'nameoncard'} . '|' . $WEBDAT{'street'} . '|' .
	$WEBDAT{'city'} . '|' . $WEBDAT{'state'} . '|' . $WEBDAT{'zip'} . '|' .
	$WEBDAT{'country'} . '|' . $WEBDAT{'phone'} .'|'. $WEBDAT{'businessname2'} . '|' . $WEBDAT{'receiveby'} . '|' . $WEBDAT{'street2'} . '|' .
	$WEBDAT{'city2'} . '|' . $WEBDAT{'state2'} . '|' . $WEBDAT{'zip2'} . '|' .
	$WEBDAT{'country2'} . '|' . $WEBDAT{'phone2'} . '|' .$WEBDAT{'notes'}. '|'. $WEBDAT{'subscribe'} .
	'||||||||||' . "\n";
	if(!$from_existing_data){
		my(@MY);
		$search_strict = 1;
		&system_busy if(!&file_lock('accounts'));
		@MY= &search_db('account.new',2,uc($WEBDAT{'email'}));
		&unlock_file('accounts');
		
		$search_strict = 0;
		&errorform("This account already exists in the database. <p>Note: This message is usually caused by accidentally clicking the Submit button twice. The good news is you have an account!<p><A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit.cgi?cid=$cart_ID\">Return To Your Shopping Cart</A> ")if(@MY);
	}
	
	my($accountnumber);
	if(!$from_existing_data){
		$accountnumber = &count_file('accounts');
		}else{
		$accountnumber = $WEBDAT{'account'};
	}
	
	if(&file_lock('accounts')){
		$line = $accountnumber . '|' . $line;
		&write_to_file('account.new',$line);
		&unlock_file('accounts');
		}else{
		&system_busy;
	}
	
	if((!$from_existing_data)&&($USERCONFIGS{'go_gift'})){
		if(!-e "$cart_directory/$cart_ID.gift"){
			open(GIFT, ">$cart_directory/$cart_ID.gift") || die $!;
			close(GIFT);
			chmod(0777, "$cart_directory/$cart_ID.gift");
		}
		
	}
	
	if(!$WEBDAT{'ao'}){
		&queryaccount;
		exit;
	}
	
	
	if($WEBDAT{'isnew'}){
		&print_document_top('New Account Established');
		print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
		print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
		print "<TABLE WIDTH=\"450\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\">\n";
		print "<TR class=\"heading\"><TD>Account Created</TD></TR>\n";
		print "    \n";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD> Your account has been successfully created. Your\n";
		print "    e-mail address is your user name: \"<B>$WEBDAT{'email'}</B>\". ";
		print "You will be asked for \n";
		print "this along with the <U>password you provided</U>.\n";
		print "    <p>\n";
		
		if($USERCONFIGS{'go_gift'}){
			
			print "<p>Note: Your account is now able to have gift deliveries. When you return to your shopping cart, you will be able to click on the Gift setting to add recipients and their delivery addresses.\n";
		}
		print "   <p> <A HREF=\"$USERCONFIGS{'shopping_entrance'}\">Store Entrance</A> ";
		print "   <p> <A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit.cgi?cid=$cart_ID\">Return To Your Shopping Cart</A> ";
		if($WEBDAT{'ssl'}){
			print sprintf("<p><A HREF=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi?command=queryaccount&cid=$cart_ID&email=%s&pass=%s\">Go to Check-Out</A>",urlencode($WEBDAT{'email'}),urlencode($WEBDAT{'pass'}));
			}else{
			print sprintf("<p><A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi?command=queryaccount&cid=$cart_ID&email=%s&pass=%s\">Go to Check-Out</A>",urlencode($WEBDAT{'email'}),urlencode($WEBDAT{'pass'}));
		}
		print " </TD>\n";
		print "    </TR>\n";
		print "    \n";
		print "</TABLE>\n";
		print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
		}else{
		&print_document_top('Account Updated');
		print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
		print "<P>\n";
		print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
		
		print "<TABLE WIDTH=\"450\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\">\n";
		print "    \n";
		
		print "<TR class=\"heading\"><TD>Account Updated</TD></TR>\n";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD> Your account has been successfully updated.";
		print "    <p>\n";
		print "   <p> <A HREF=\"$USERCONFIGS{'shopping_entrance'}\">Store Entrance</A> ";
		print "   <p> <A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit.cgi?cid=$cart_ID\">Return To Your Shopping Cart</A> ";
		
		if(-e "$cart_directory/$cart_ID.cart"){
			if(-s "$cart_directory/$cart_ID.cart"){
				
				if($WEBDAT{'ssl'}){
					
					print sprintf("<p><A HREF=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi?command=queryaccount&cid=$cart_ID&email=%s&pass=%s\">Go to Checkout</A>",urlencode($WEBDAT{'email'}),urlencode($WEBDAT{'pass'}));
					}else{
					print sprintf("<p><A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi?command=queryaccount&cid=$cart_ID&email=%s&pass=%s\">Go to Checkout</A>",urlencode($WEBDAT{'email'}),urlencode($WEBDAT{'pass'}));
				}
				
			}
		}
		
		print " </TD>\n";
		print "    </TR>\n";
		print "    \n";
		print "</TABLE>\n";
		print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
		
	}
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
	
	
}



sub show_confirm_screen{
	&set_cart_status;
	&get_account;
	my $m__errors = 0;
	if($WEBDAT{'method'} eq ""){
		$m__errors++;
		$ERROR{'pay_method'} = &get_error_string('You did not select a payment method.');
	}
	
	if($WEBDAT{'web_shipping_fee'} eq '' &&  $WEBDAT{'web_shipping_fee_enabled'}){
		$m__errors++;
		$ERROR{'shippingerr'} = &get_error_string('You did not select a shipping option.');
	}
	
	&queryaccount if($m__errors);
	
	
	
	
	
	&print_document_top('Checkout Stand');
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	
	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
	}
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
	
	
	print &show_cartit(0);
	print "<p>&nbsp</p>";
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "<TABLE CELLPADDING=\"5\" CELLSPACING=\"0\" BORDER=\"0\" WIDTH=\"500\">\n";
	
	
	
	
	
	
	if($WEBDAT{'method'} ne "1"){
		
		print "        <TR class=\"smallheading\"><TD COLSPAN=\"2\">\n";
		
		print "Payment Method ";
		print "</TD></TR>\n";
		print "        <TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">\n";
		print "<INPUT TYPE=\"hidden\" NAME=\"method\" VALUE=\"$WEBDAT{'method'}\">";
		
		if($WEBDAT{'method'} eq "1"){
			print "<p>Please complete the credit card information below. This information is required to process your order.\n";
			
			}elsif($WEBDAT{'method'} eq "2"){
			print "You have chosen to pay with your credit card by phone. The next screen will provide our company contact information so you may contact us during business hours. If your call is not received, we will contact you at $WEBDAT{'phone'}.\n";
			}elsif($WEBDAT{'method'} eq "3"){
			print "You have chosen to pay by C.O.D.";
			print " Please have a certified check or money order available for delivery personnel.";
			
			
			}elsif($WEBDAT{'method'} eq "4"){
			print "<p>Purchase Order Number\n";
			print "<INPUT TYPE=\"text\" NAME=\"purchase_order\" SIZE=\"6\" MAXLENGTH=\"15\"> &lt;- required\n";
			}elsif($WEBDAT{'method'} eq "5"){
			print "$USERCUSTOM{'REMOTE_SSL_CONFIRM_TEXT'}\n";
			}elsif($WEBDAT{'method'} eq "6"){
			print "You have chosen to mail your payment to $USERCONFIGS{'company_name'}. Print and mail the invoice on the next screen. You should print two copies, one for your records and one to mail to us. <I>The next screen will provide our address information.</I>\n";
		}
		print "</TD></TR>\n";
		
		}else{
		&print_cc_input_section(0);
		
		
		print "		</TABLE>\n";
		print "		</TD></TR></TABLE></TD></TR>\n";
		
		print "		<P>\n";
		
	}
	
	if(-e "$data_directory/disclaimer.html"){
		if(-s "$data_directory/disclaimer.html"){
			
			print "        <TR class=\"smallheading\"><TD COLSPAN=\"2\">\n";
			print "$USERCUSTOM{'DISCLAIMER_HEADER'}";
			print "</TD></TR>\n";
			
			
			print "<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">\n";
			print "<TABLE WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\">\n";
			print "<TR class=\"checkouttablebody\">\n";
			print "<TD VALIGN=\"TOP\">\n";
			&put_file('disclaimer.html');
			print "</TD></TR></TABLE>\n";
			print "</TD></TR>\n";
		}
	}
	
	
	
	
	
	
	print "        <INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"show_invoice\">\n";
	print "        <INPUT TYPE=\"HIDDEN\" NAME=\"email\" VALUE=\"$WEBDAT{'email'}\">\n";
	print "        <INPUT TYPE=\"HIDDEN\" NAME=\"pass\" VALUE=\"$WEBDAT{'pass'}\">\n";
	print "        <INPUT TYPE=\"HIDDEN\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
	print "        <TR class=\"smallheading\"><TD COLSPAN=\"2\">\n";
	print "        Your order total is:\n";
	print "        <span class=price>$USERCONFIGS{'money_sign'}$gtotal</span> ";
	print "</TD></TR>\n";
	print "        <TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">\n";
	
	print "        <p>If the total displayed is acceptable and you would like to process your order, please\n";
	print "        click the button below.<p>\n";
	
	
	
	print "<INPUT TYPE=\"submit\" VALUE=\"Process Order\">";
	print "</TD></TR>\n";
	
	print "        <TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">\n";
	print " The following screen will provide you with a detailed invoice\n";
	print "        of your order and further instructions if applicable.\n";
	print "        <P>       \n";
	print "</TD></TR>\n";
	print "</FORM>\n";
	
	
	
	
	
	print "</TABLE>\n";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	
	
	
	exit;
	
}
sub show_invoice{
	
	&print_http_header;
	if(!-e "$cart_directory/$cart_ID.cart"){
		&errorform('Your shopping cart has already been processed! This error is most likely caused by submitting the form twice.<p>The first time you submitted the form, your shopping cart was processed. We attempted to send you an invoice response, but you interrupted the transfer by submitting the form a second time. <p>When you submitted the form a second time, we could not process your shopping cart. It was marked as being processed by the first submission. Thus, you received this message!<p>You should receive a confirmation via e-mail, sent with the first submission.');
	}
	
	if(-z "$cart_directory/$cart_ID.cart"){
		&errorform('Your shopping cart has already been processed! This error is most likely caused by submitting the form twice.<p>The first time you submitted the form, your shopping cart was processed. We attempted to send you an invoice response, but you interrupted the transfer by submitting the form a second time. <p>When you submitted the form a second time, we could not process your shopping cart. It was marked as being processed by the first submission. Thus, you received this message!<p>You should receive a confirmation via e-mail, sent with the first submission.');
	}
	
	
	my($invoice,$inv_number,$mydate);
	
	
	
	if($WEBDAT{'method'} eq "4"){
		&errorform('No purchase order number was entered.')if($WEBDAT{'purchase_order'} eq "");
		$USERCONFIGS{'po_number'} =  "Purchase Order Number: $WEBDAT{'purchase_order'}";
	}
	
	
# Check the card now if we are not using Real time cc processing.
	if($WEBDAT{'method'} eq "1" && !$USERCONFIGS{'cc_rtime'}){
		my $check_card_res = &check_card;
		&show_confirm_screen if($check_card_res);
	}
	
	
	&get_account;
	my($mytime) = time();
	$USERCONFIGS{'order_date_time'} =&get_date($mytime,1);
	$USERCONFIGS{'order_number'} = &count_file('invoices');
	&get_webdat_io;
	
	
	
	
	
	
	&system_busy if(!&file_lock('orders'));
	
	$affiliate = '';
	if($AFFILIATE_MODULE_LOADED){
		$affiliate = &parse_affiliate;
	}
	

	
	
	$line =  $USERCONFIGS{'order_number'} . '|' . $WEBDAT{'account'} . '|' .$WEBDAT{'pass'} . '|' . $WEBDAT{'email'} .'|'. $WEBDAT{'businessname'} . '|' . $WEBDAT{'nameoncard'} . '|' . $WEBDAT{'street'} . '|' .
	$WEBDAT{'city'} . '|' . $WEBDAT{'state'} . '|' . $WEBDAT{'zip'} . '|' .
	$WEBDAT{'country'} . '|' . $WEBDAT{'phone'} .'|'. $WEBDAT{'businessname2'} . '|' . $WEBDAT{'receiveby'} . '|' . $WEBDAT{'street2'} . '|' .
	$WEBDAT{'city2'} . '|' . $WEBDAT{'state2'}  . '|' . $WEBDAT{'zip2'} . '|' .
	$WEBDAT{'country2'} . '|' . $WEBDAT{'phone2'} . '|' .$WEBDAT{'notes'} . '|' .
	$USERCONFIGS{'order_date_time'} .'|'. $WEBDAT{'total'} .'|'. $WEBDAT{'method'} .'|'. $WEBDAT{'ccnum'} .'|'.
	$WEBDAT{'ccname'} .'|'. $WEBDAT{'ccmo'} .'|'. $WEBDAT{'ccyr'}  .'|'. $WEBDAT{'ccphone'} .'|'. $WEBDAT{'purchase_order'} .'|'.
	$affiliate .'|'. $WEBDAT{'coupon'} .'|New';
	
	
	open(FILE, ">>$data_directory/neworder.txt")||&emergency_unlock_file('orders','Could not open neworder.txt');
	print FILE "$line\n";
	close(FILE);
	
	$PROCESS_COUNTRY = 1;
	$USERCONFIGS{'recipient_list'} =&get_recipient_list;
	$USERCONFIGS{'text_recipient_list'} =&get_recipient_list_string;
	$USERCONFIGS{'shopping_cart'} =  &show_cartit(0);

	&custom_payment_routine;
	
#$USERCONFIGS{'text_shopping_cart'} =&get_mailinvoice;
	$invoice_string = &get_file_as_iostring('cartit_invoice.html');
	$cm_invoice_string = &get_file_as_iostring('cartit_cb_invoice.html');
	
	$invoice_string =~ s!\s+! !g;
	$cm_invoice_string=~ s!\s+! !g;
	if($WEBDAT{'method'}!=5){
		$invoice_string  =~ s!<%IO_REMOTE%>(.*)</%IO_REMOTE%>!!i;
		}else{
		$invoice_string  =~ s!<%IO_REMOTE%>(.*)</%IO_REMOTE%>!$1!i;
	}
	
	
	
	
	
	if(open(FILE, ">>$data_directory/neworder.dat")){
		print FILE "CartItBeginInvoice|$USERCONFIGS{'order_number'}<!--END-->\n";
		print FILE "$cm_invoice_string\n";
		print FILE "CartItEndInvoice|$USERCONFIGS{'order_number'}\n\n";
		close(FILE);
	}
	
	&unlock_file('orders');
	
	
######################################################################
# Here we print out an error and stop processing, we do not want to kill
# the carts, print an invoice or send mail. We do however, what to
# perform the above, as we want the 'merchant' to have access to
# the invoice information the validate CC routine will log the
# invoice CC notes for the order and mark it AutoVoid if needed.
# the shopper will get a rejection notice and prompt to input cc
#  information again. the cc validation system may ban the shopper
# from submitting again if needed, the shopper will get this
# information upon submitting again.
######################################################################
	if($WEBDAT{'method'} == 1 && $USERCONFIGS{'cc_rtime'}){
		my $check_card_res = &check_card;
		&show_confirm_screen if($check_card_res);
	}
	
	unlink("$cart_directory/$cart_ID.cart") if(-e "$cart_directory/$cart_ID.cart");
	unlink("$cart_directory/$cart_ID.gift") if(-e "$cart_directory/$cart_ID.gift");
	
	my($BODY) = &get_file_as_iostring('cartit_customer_invoice.html');
	my($MERCHANTBODY) = &get_file_as_iostring('cartit_invoice_notice.html');
	
	&send_mail("$WEBDAT{'email'}","$USERCONFIGS{'infomail'}","Your Order at $USERCONFIGS{'company_name'} \#$USERCONFIGS{'order_number'}","$BODY","text/html");
	&send_mail("$USERCONFIGS{'ordermail'}","$WEBDAT{'email'}","Online Order \#$USERCONFIGS{'order_number'}","$MERCHANTBODY","text/html");
	
	
	&kill_carts;
	
	print "$invoice_string";
	
	exit;
	
}



sub manageit{
	if($WEBDAT{'email'} eq ""){
		&errorform('You did not enter an e-mail address.');
		}elsif($WEBDAT{'pass'} eq ""){
		&errorform('You did not enter a password.');
	}
	if(&get_account){
		&account_manager(0);
		}else{
		&show_mail_it_to_me;
	}
}


sub account_manager{
	my($createnew) = shift;
	if(!$createnew){
		&print_document_top('Modify Account');
		print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
		}else{
		&print_document_top('Establish a New Account');
		print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
	}
	
	&put_file('validate.html');
	
	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\" NAME=\"ORDERFM\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\" NAME=\"ORDERFM\">\n";
	}
	
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "<TABLE WIDTH=\"550\" CELLPADDING=\"6\" CELLSPACING=\"0\" BORDER=\"0\">\n";
	
	
	
	if($ISERROR){
		print "<TR class=\"heading\"><TD COLSPAN=\"2\">YOUR HAVE ERRORS</TD></TR>\n";
		print "<TR class=\"inputerror\"><TD  colspan=\"2\">You have errors in your form input information, please see below.</TD></TR>";
	}
	if(!$createnew){
		
		
		
		print "<TR class=\"heading\"><TD COLSPAN=\"2\">My Account Profile</TD></TR>\n";
		print "  <TR class=\"checkouttablebody\">\n";
		print "  <TD COLSPAN=\"2\">";
		print "<U>You can not change your e-mail address or password</U>. This is done for <U>your protection</U>. ";
		print " If you would like to change your e-mail address or password, please contact our customer service";
		print " department or create a ";
		if($WEBDAT{'ssl'}==1){
			print "<A HREF=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi?command=checkout\">new account</A>.";
			}else{
			print "<A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi?command=checkout\">new account</A>.";
		}
		
		
		
		if(($WEBDAT{'ao'})&&(-e "$cart_directory/$cart_ID.cart")){
			if(-s "$cart_directory/$cart_ID.cart"){
				print "<p> NOTE: You are in account management mode. If you wish to check out you can do so here: ";
				if($WEBDAT{'ssl'}==1){
					print sprintf("<A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi?command=queryaccount&cid=$cart_ID&email=%s&pass=%s\">Check Out</A>",urlencode($WEBDAT{'email'}),urlencode($WEBDAT{'pass'}));
					}else{
					print sprintf("<A HREF=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi?command=queryaccount&cid=$cart_ID&email=%s&pass=%s\">Check Out</A>",urlencode($WEBDAT{'email'}),urlencode($WEBDAT{'pass'}));
				}
			}
		}
		
		
		
		
		print "</TD></TR>";
		}else{
		print "<TR class=\"heading\"><TD COLSPAN=\"2\">New Account</TD></TR>\n";
		print "  <TR class=\"checkouttablebody\">\n";
		print "  <TD COLSPAN=\"2\">";
		print "Your e-mail address was not on file. We will now guide you through the account creation process with $USERCONFIGS{'company_name'}.";
		print "  \n";
		print "</TD></TR>\n";
		
	}
	
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"ao\" VALUE=\"$WEBDAT{'ao'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"creatingnew\" VALUE=\"$createnew\">\n";
	
	
	print "<TR class=\"smallheading\"><TD COLSPAN=\"2\">Account E-mail</TD></TR>";
	
	
	print "<TR class=\"checkouttablebody\"> \n";
	print "<TD>E-mail Address</TD>\n";
	print " <TD>$WEBDAT{'email'}</TD>\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"email\" VALUE=\"$WEBDAT{'email'}\">\n";
	print "        </TR>\n";
	
	
	print "<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">";
	print "   <INPUT TYPE=\"CHECKBOX\" NAME=\"subscribe\" VALUE=\"1\"";
	print " CHECKED\n" if($WEBDAT{'subscribe'});
	print ">";
	print "Check this box if you would like to \n";
	print "receive e-mail notification of specials and site changes.</TD>\n";
	print "    </TR>\n";
	
	
	
	
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"account\" VALUE=\"$WEBDAT{'account'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"email\" VALUE=\"$WEBDAT{'email'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
	
	
	if($USERCUSTOM{'allow_separate_shipping'}){
		print "<TR class=\"smallheading\"> <TD COLSPAN=\"2\">Account Billing Information</TD></TR>";
		print "    \n";
		print "    <TR class=\"checkouttablebody\"> \n";
		print "    <TD COLSPAN=\"2\">";
		if($USERCUSTOM{'allow_separate_shipping'}){
			print "This address should reflect the <U>billing address</U> for all purchases you \n";
			print "will make with $USERCONFIGS{'company_name'}.";
		}
		&put_file('checkout_billing_address.html');
		
		print "   </TD> </TR>\n";
		}else{
		print "<TR class=\"smallheading\"> <TD COLSPAN=\"2\">Account Address Information</TD></TR>";
		
	}
	
	
	print "    <TR class=\"checkouttablebody\"> \n";
	
	print " <TD>Company Name</TD> \n";
	print "<TD><INPUT TYPE=\"TEXT\" NAME=\"businessname\" VALUE=\"$WEBDAT{'businessname'}\" SIZE=\"30\" MAXLENGTH=\"40\"> Optional</TD>\n";
	print "    </TR>\n";
	print "$ERROR{'nameoncard'}";
	print "<TR class=\"checkouttablebody\">\n";
	print "<TD>Name</TD> \n";
	print "<TD><INPUT TYPE=\"TEXT\" NAME=\"nameoncard\" VALUE=\"$WEBDAT{'nameoncard'}\" SIZE=\"30\" MAXLENGTH=\"40\"></TD>\n";
	print "    </TR>\n";
	print "$ERROR{'street'}";
	print "    <TR class=\"checkouttablebody\"> \n";
	print "    <TD>Street Address</TD> \n";
	print "<TD><INPUT TYPE=\"TEXT\" NAME=\"street\" SIZE=\"30\" VALUE=\"$WEBDAT{'street'}\"  MAXLENGTH=\"100\"></TD>\n";
	print "    </TR>\n";
	print "    \n";
	print "$ERROR{'city'}";
	print "    <TR class=\"checkouttablebody\"> \n";
	print "    <TD>City</TD> \n";
	print "<TD><INPUT TYPE=\"TEXT\" NAME=\"city\" SIZE=\"30\" VALUE=\"$WEBDAT{'city'}\" MAXLENGTH=\"40\"></TD>\n";
	print "    </TR>\n";
	print "    \n";
	print "$ERROR{'state'}";
	print "    <TR class=\"checkouttablebody\">\n";
	print "\n";
	print "    <TD>State / Province</TD>\n";
	print " <TD><INPUT TYPE=\"TEXT\" NAME=\"state\" SIZE=\"30\"  VALUE=\"$WEBDAT{'state'}\" MAXLENGTH=\"50\"> </TD>\n";
	print "    </TR>\n";
	
	
	
	print "    <TR class=\"checkouttablebody\">\n";
	print "\n";
	print "    <TD COLSPAN=\"2\">";
	print " U.S. Customer: Please enter only your <U>2 character</U> state code. </TD>\n";
	print "    </TR>\n";
	print "$ERROR{'zip'}";
	print "    <TR class=\"checkouttablebody\">\n";
	print "\n";
	print "    <TD>Zip / Postal Code</TD>\n";
	print " <TD><INPUT TYPE=\"TEXT\" NAME=\"zip\" SIZE=\"30\"  VALUE=\"$WEBDAT{'zip'}\" MAXLENGTH=\"50\"></TD>\n";
	print "    </TR>\n";
	
	
	
	print "    <TR class=\"checkouttablebody\">\n";
	print "\n";
	print "    <TD COLSPAN=\"2\">";
	print " U.S. Customer: Please enter only your <U>5 digit</U> zip code. </TD>\n";
	print "    </TR>\n";
	print "$ERROR{'country'}";
	print "    \n";
	print "    <TR class=\"checkouttablebody\">\n";
	print "    <TD>Country</TD> \n";
	print "<TD>  <SELECT NAME=\"country\"> \n";
	print "<OPTION VALUE=\"US\">United States</OPTION>\n";
	
	foreach $country (sort keys %COUNTRIES){
		if(($WEBDAT{'country'} eq "$COUNTRIES{$country}")&&($WEBDAT{'country'} ne "US")){
			print "<OPTION VALUE=\"$COUNTRIES{$country}\" SELECTED>$country</OPTION>\n";
			}else{
			print "<OPTION VALUE=\"$COUNTRIES{$country}\">$country</OPTION>\n";
		}
	}
	
	print " </SELECT> </TD>\n";
	print "    </TR>\n";
	print "    \n";
	print "$ERROR{'phone'}";
	print "    <TR class=\"checkouttablebody\">\n";
	print "    <TD>Day Phone</TD> \n";
	print "<TD><INPUT TYPE=\"TEXT\" NAME=\"phone\"  VALUE=\"$WEBDAT{'phone'}\" SIZE=\"30\" MAXLENGTH=\"20\"></TD>\n";
	print "    </TR>\n";
	print "    \n";
	
	
	
	
	
	
	
	$GLOBAL_HAS_GIFTS = &check_gift_items;
	
	if(!$USERCUSTOM{'allow_separate_shipping'} || $GLOBAL_HAS_GIFTS ==1){
		print "<INPUT TYPE=\"HIDDEN\" NAME=\"sameasbilling\" VALUE=\"1\">\n";
		}else{
		
		print "<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">&nbsp;</TD></TR>";
		print "<TR class=\"smallheading\"> <TD COLSPAN=\"2\">Account Shipping Information</TD></TR>";
		
		
		
		print "<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">The shipping profile is information regarding where the order will be shipped.";
		print "<p>";
		
		
		if($GLOBAL_HAS_GIFTS==2){
			print qq[
			
			<table cellpadding="0" cellspacing="1" border="0" bgcolor="#000000">
			<tr>
			<td>
			
			<table cellpadding="5" cellspacing="0" border="0" class=warning>
			<tr>
			<td>
			<b>IMPORTANT</b> Some of the items in your shopping cart are not marked as gifts, please provided a shipping address for those items. <u>This shipping information applies only to those <b>non-gift</b> items</u>.
			</td>
			</tr>
			</table>
			
			</td>
			</tr>
			</table>
			<p>
			];
		}
		
		
		print "   <INPUT TYPE=\"CHECKBOX\" NAME=\"sameasbilling\" VALUE=\"1\"";
		print " CHECKED\n" if($WEBDAT{'sameasbilling'});
		print ">";
		
		
		print "<b>Check this box if you want your order shipped to your billing address.</b><br>\n";
		print "If you want your order shipped to an address other than your billing address, do not check this box and enter the shipping information below.";
		
		print "</TD></TR>";
		
		
		print "    <TR class=\"checkouttablebody\"> \n";
		print "    <TD>Company Name</TD> \n";
		print "<TD><INPUT TYPE=\"TEXT\" NAME=\"businessname2\"  VALUE=\"$WEBDAT{'businessname2'}\" SIZE=\"30\" MAXLENGTH=\"40\"> Optional</TD>\n";
		print "    </TR>\n";
		
		print "$ERROR{'receiveby'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD>Name</TD> \n";
		print "<TD><INPUT TYPE=\"TEXT\" NAME=\"receiveby\" VALUE=\"$WEBDAT{'receiveby'}\" SIZE=\"30\" MAXLENGTH=\"40\"></TD>\n";
		print "    </TR>\n";
		print "$ERROR{'street2'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD>Street Address</TD> \n";
		print "<TD><INPUT TYPE=\"TEXT\" NAME=\"street2\" VALUE=\"$WEBDAT{'street2'}\" SIZE=\"30\" MAXLENGTH=\"100\"></TD>\n";
		print "    </TR>\n";
		print "    \n";
		print "$ERROR{'city2'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD>City</TD> \n";
		print "<TD><INPUT TYPE=\"TEXT\" NAME=\"city2\" VALUE=\"$WEBDAT{'city2'}\" SIZE=\"30\" MAXLENGTH=\"40\"></TD>\n";
		print "    </TR>\n";
		print "    \n";
		print "$ERROR{'state2'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "\n";
		print "    <TD>State / Province</TD>\n";
		print " <TD><INPUT TYPE=\"TEXT\" NAME=\"state2\" SIZE=\"30\"  VALUE=\"$WEBDAT{'state2'}\" MAXLENGTH=\"50\"> </TD>\n";
		print "    </TR>\n";
		
		
		print "    <TR class=\"checkouttablebody\">\n";
		print "\n";
		print "    <TD COLSPAN=\"2\">";
		print " U.S. Customer: Please enter only your <U>2 character</U> state code. </TD>\n";
		print "    </TR>\n";
		
		
		print "$ERROR{'zip2'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "\n";
		print "    <TD>Zip / Postal Code</TD>\n";
		print " <TD><INPUT TYPE=\"TEXT\" NAME=\"zip2\" VALUE=\"$WEBDAT{'zip2'}\" SIZE=\"30\" MAXLENGTH=\"20\"></TD>\n";
		print "    </TR>\n";
		
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD COLSPAN=\"2\">";
		print " U.S. Customer: Please enter only your <U>5 digit</U> zip code. </TD>\n";
		print "    </TR>\n";
		
		print "$ERROR{'country2'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD>Country</TD> \n";
		print "<TD>  <SELECT NAME=\"country2\"> \n";
		print "<OPTION VALUE=\"US\">United States</OPTION>\n";
		foreach $country (sort keys %COUNTRIES){
			if(($WEBDAT{'country2'} eq "$COUNTRIES{$country}")&&($WEBDAT{'country2'} ne "US")){
				print "<OPTION VALUE=\"$COUNTRIES{$country}\" SELECTED>$country</OPTION>\n";
				}else{
				
				print "<OPTION VALUE=\"$COUNTRIES{$country}\">$country</OPTION>\n";
			}
		}
		
		print " </SELECT> </TD>\n";
		print "    </TR>\n";
		print "$ERROR{'phone2'}";
		print "    <TR class=\"checkouttablebody\">\n";
		print "    <TD>Day Phone</TD> \n";
		print "<TD><INPUT TYPE=\"TEXT\" NAME=\"phone2\" VALUE=\"$WEBDAT{'phone2'}\" SIZE=\"30\" MAXLENGTH=\"20\"></TD>\n";
		print "    </TR>\n";
	}
	
	
	
	if($createnew){
		print "<TR class=\"smallheading\"><TD COLSPAN=\"2\">Account Password</TD></TR>";
		
		
		print "        <TR class=\"checkouttablebody\">\n";
		print "        <TD COLSPAN=\"2\">Create a password for yourself.\n";
		print " Enter the exact same password in both boxes. The password is case sensitive.</TD>\n";
		print "        </TR>\n";
		
		if($WEBDAT{'isnew'}){
			print &get_error_string('Passwords do not match or were not entered.')if($WEBDAT{'pass'} ne  $WEBDAT{'pass2'});
			
		}
		
		print " <TR class=\"checkouttablebody\"><TD>Password</TD> \n";
		print "<TD><INPUT TYPE=\"PASSWORD\" NAME=\"pass\" VALUE=\"$WEBDAT{'pass'}\" SIZE=\"10\" MAXLENGTH=\"10\"></TD>\n";
		print "        </TR>\n";
		print "        \n";
		print "        <TR class=\"checkouttablebody\"> \n";
		print "        <TD>Confirm Password</TD>\n";
		if(-e "$data_directory/validate.html"){
			print " <TD><INPUT TYPE=\"PASSWORD\" NAME=\"pass2\"  VALUE=\"$WEBDAT{'pass2'}\"  SIZE=\"10\" MAXLENGTH=\"10\" OnBlur=\"return PassMatch()\"></TD>\n";
			}else{
			print " <TD><INPUT TYPE=\"PASSWORD\" NAME=\"pass2\"  VALUE=\"$WEBDAT{'pass2'}\"  SIZE=\"10\" MAXLENGTH=\"10\"></TD>\n";
		}
		print "</TR>\n";
		
		
		
		}else{
		print "<INPUT TYPE=\"hidden\" NAME=\"pass\" VALUE=\"$WEBDAT{'pass'}\">\n";
	}
	
	print "<TR class=\"smallheading\"><TD COLSPAN=\"2\">Optional Notes</TD></TR>";
	print "    <TR class=\"checkouttablebody\">\n";
	print "    <TD COLSPAN=\"2\">Notes may include anything you ";
	print "feel we should know about this account, perhaps any special delivery or billing instructions. (Maximum of 250 Characters.)</TD> \n";
	print "    </TR>\n";
	
	print "    <TR class=\"checkouttablebody\">\n";
	print "    <TD COLSPAN=\"2\"><INPUT TYPE=\"TEXT\" NAME=\"notes\" VALUE=\"$WEBDAT{'notes'}\"SIZE=\"35\" MAXLENGTH=\"250\"></TD>\n";
	print "    </TR>\n";
	
	
	if(!$createnew){
		print "    <INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"modify_account\">\n";
		}else{
		print "    <INPUT TYPE=\"HIDDEN\" NAME=\"isnew\" VALUE=\"1\">\n";
		print "    <INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"postnewaccount\">\n";
	}
	
	
	print "    <TR class=\"checkouttablebody\">\n";
	print "    <TD COLSPAN=\"2\">\n";
	if(-e "$data_directory/validate.html"){
		print "<INPUT TYPE=\"submit\" VALUE=\"Submit Form\" OnClick=\"return(Validate())\">\n";
		}else{
		
		print "<INPUT TYPE=\"submit\" VALUE=\"Submit Form\">\n";
	}
	
	
	print "    </TD></TR>    \n";
	print "  </TABLE>";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print "  </FORM>\n";
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
	
}


sub modify_account{
	&check_user_data;
	&errorform('An error occurred when we attempted to look up your account information.')if(!&get_account(1));
	if(&delete_account){
		post_new_account(1); #from_existing_data
		}else{
		&errorform('An error occurred when we attempted to update your account information.');
	}
}




sub intlogin{
	
	
	init_l_error('You did not enter a valid e-mail address')if(!&valid_mail($WEBDAT{'email'}));
	
	
# Do New Account First.
	
	if($WEBDAT{'passmethod'} == 0){
		if(!&get_account(1)){
			&account_manager(1)
			}else{
			&show_mail_it_to_me;
			
			
		}
		
		
		}else{ # Existing.
		
		
		
		init_l_error('You did not enter a valid password.')if($WEBDAT{'pass'} eq '');
		
		
		
		
		if(&get_account(0)){
			if($WEBDAT{'ao'} ==1){
				&manageit;
				}elsif($WEBDAT{'ao'} ==2){
				print "Location: $USERCONFIGS{'ssl_cgi_bin'}/cartit.cgi?cid=$cart_ID\&ao=2\n\n";
				}else{
				&queryaccount;
			}
			exit;
		}
	}
	
	
	if(!&get_account(1)){
		init_l_error('The e-mail address you entered does not match an account in our database. Please check for typos. If it was entered correctly, please create a new account by selecting "I am a new customer."')if(!&get_account(1));
		}else{
		&show_mail_it_to_me;
	}
	
	
	
	sub init_l_error{
		my $error = shift;
		$LOGIN_ERROR = "<span class=\"inputerror\">$error</span>";
		&checkout;
		exit;
		
		
		
	}
	
	
}



sub show_mail_it_to_me{
	&print_document_top('Account Exists');
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "<TABLE WIDTH=\"550\" CELLPADDING=\"4\" CELLSPACING=\"0\" BORDER=\"0\">\n";
	print "<TR class=\"heading\"><TD>Lost your Password?</TD></TR>\n";
	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\" NAME=\"ACCT\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\" NAME=\"ACCT\">\n";
	}
	print "<TR class=\"checkouttablebody\"><TD>This account exists. You can have your password e-mailed to you if you want. We will not provide this password online because this would allow anyone to access your account. Having your password e-mailed to you allows only the person at \"$WEBDAT{'email'}\" to receive the account information.</TD></TR>\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"email\" VALUE=\"$WEBDAT{'email'}\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"do_mailittome\">\n";
	print "<TR><TD><INPUT TYPE=\"submit\" VALUE=\"Mail It To Me\"><p></TD></TR>\n";
	print "</TABLE>\n";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print "</FORM>\n";
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
	
	
}

sub do_mailittome{
	if(!&get_account(2)){
		&errorform('An error occurred while looking up your account information.');
	}
	
	$BODY = &get_file_as_iostring('yourpassword.txt');
	if(!&send_mail("$WEBDAT{'email'}","$USERCONFIGS{'infomail'}","Your Account Password","$BODY","text/plain")){
		&errorform('An error occurred while attempting to send your account information.');
	}
	
	
	&print_document_top('Account Sent');
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'header.html');
	print "<CENTER><DIV ALIGN=\"CENTER\">" if(!$NOCENTER_CHECKOUT);
	print "<TABLE WIDTH=\"550\" CELLPADDING=\"2\" CELLSPACING=\"2\" BORDER=\"0\">\n";
	print "<TR class=\"heading\"><TD>Account Found</TD></TR>\n";
	if($WEBDAT{'ssl'}==1){
		print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\" NAME=\"ACCT\">\n";
		}else{
		print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\" NAME=\"ACCT\">\n";
	}
	print "<TR class=\"checkouttablebody\"><TD>The account information was mailed to  \"$WEBDAT{'email'}\". This message should arrive several seconds to several minutes from now.";
	print "<p>You can <A HREF=\"$USERCONFIGS{'home_page'}\">return to our homepage</A> or you can click your web browser's Back button and wait for your password to arrive.</TD></TR>\n";
	print "</TABLE>\n";
	print "</DIV></CENTER>" if(!$NOCENTER_CHECKOUT);
	print "</FORM>\n";
	print &get_file_as_iostring('checkout' . $ssl_file_txt . 'footer.html');
	&print_document_foot;
	exit;
}



sub get_recipient_list{
	$retvalgift = '';
	return($retvalgift)if(!$USERCONFIGS{'go_gift'});
	return($retvalgift)if(!-e "$cart_directory/$cart_ID.gift");
	return($retvalgift)if(!-s "$cart_directory/$cart_ID.gift");
	
	open(GIFT, "$cart_directory/$cart_ID.gift") || return($retvalgift);
	@GRL = (<GIFT>);
	close(GIFT);
	chomp(@GRL);
	
	
	
	
	if(@GRL){
		
		$retvalgift .="<TABLE CELLPADDING=\"3\" CELLSPACING=\"3\" BORDER=\"0\"><TR><TD>\n";
		$retvalgift .="Recipient List<p>\n";
		foreach $giftperson (@GRL){
			($gname, $company, $realname, $street, $city, $state, $zip, $country, $gift,$gift_message,$deldate) = split(/\|/,$giftperson);
			$retvalgift .="<TABLE CELLPADDING=\"3\" CELLSPACING=\"0\" BORDER=\"1\" WIDTH=\"500\">\n";
			
			$retvalgift .=  "<TR><TD><B>$gname</B></TD></TR><TR><TD>\n";
			$retvalgift .= "$company<BR>"if($company ne "");
			$retvalgift .="$realname<BR>\n";
			$retvalgift .="$street<BR>\n";
			$retvalgift .="$city, $state $zip<BR>\n";
			$retvalgift .="$country</TD></TR>\n";
			if($gift ne ""){
				my($g,$p) = split(/\^/,$gift);
				$retvalgift .="<TR><TD><I>$g</I></TD></TR>";
			}
			
			if($gift_message ne ""){
				$retvalgift .="<TR><TD><I>$gift_message</I></TD></TR>";
			}
			if($deldate ne ""){
				$retvalgift .="<TR><TD><I>$deldate</I></TD></TR>";
			}
			
			
			
			
			$retvalgift .="</TABLE><P>";
			
			
			
		}
		
		$retvalgift .="</TD></TR></TABLE>\n";
		
		return($retvalgift);
	}
	
}












sub get_recipient_list_string{
	$retvalgift = '';
	return($retvalgift)if(!$USERCONFIGS{'go_gift'});
	return($retvalgift)if(!-e "$cart_directory/$cart_ID.gift");
	return($retvalgift)if(!-s "$cart_directory/$cart_ID.gift");
	
	open(GIFT, "$cart_directory/$cart_ID.gift") || return($retvalgift);
	@GRL = (<GIFT>);
	close(GIFT);
	chomp(@GRL);
	
	
	
	
	if(@GRL){
		
		$retvalgift .="Recipient List\n";
		foreach $giftperson (@GRL){
			($gname, $company, $realname, $street, $city, $state, $zip, $country, $gift,$gift_message,$deldate) = split(/\|/,$giftperson);
			
			$retvalgift .=  "$gname\n";
			$retvalgift .= "$company\n"if($company ne "");
			$retvalgift .="$realname\n";
			$retvalgift .="$street\n";
			$retvalgift .="$city, $state $zip\n";
			$retvalgift .="$country\n";
			if($gift ne ""){
				my($g,$p) = split(/\^/,$gift);
				$retvalgift .="$g\n";
			}
			
			if($gift_message ne ""){
				$retvalgift .="$gift_message\n";
			}
			if($deldate ne ""){
				$retvalgift .="$deldate\n";
			}
			
			
			
			
			$retvalgift .="\n\n\n";
			
			
			
		}
		
		return($retvalgift);
	}
	
}

#-----------------------------------------------------------
sub kill_carts{
	@carts = &read_directory($cart_directory,'.*\.cart|.*\.gift');
	foreach $cart (@carts){
		if (-M "$cart_directory/$cart" > .5){
			unlink("$cart_directory/$cart");
		}
	}
	
# banned users.
	@carts = &read_directory($cart_directory,'.*\.banned');
	foreach $cart (@carts){
		if (-M "$cart_directory/$cart" > 3){
			unlink("$cart_directory/$cart");
		}
	}
	
	
}

sub show_standard_account_profile{
	my($gomodacc) = shift;
	
	
	
	print "	<TR class=\"smallheading\"><TD WIDTH=\"50%\">BILL TO:</TD><TD>SHIP TO:</TD></TR>\n";
	
	print "<TR class=\"checkouttablebody\"><TD VALIGN=\"TOP\">";
	if($WEBDAT{'businessname'} ne ""){
		print "$WEBDAT{'businessname'}<BR>\n";
	}
	
	print "	$WEBDAT{'nameoncard'}<BR>\n";
	
	print "		$WEBDAT{'street'}<BR>\n";
	print "		$WEBDAT{'city'}, $WEBDAT{'state'}  $WEBDAT{'zip'}<BR>\n";
	print "		$WEBDAT{'country'}<BR>\n";
	print "		\n";
	print "		$WEBDAT{'phone'}<p>$WEBDAT{'email'}</TD>\n";
	print "\n";
	
	print "<TD VALIGN=\"TOP\">\n";
	
	
	if($GLOBAL_HAS_GIFTS==2){
		print qq[
		
		<table cellpadding="0" cellspacing="1" border="0" bgcolor="#000000">
		<tr>
		<td>
		
		<table cellpadding="5" cellspacing="0" border="0" class=warning>
		<tr>
		<td>
		<b>IMPORTANT</b> Some of the items in your shopping cart are not marked as gifts. This shipping information applies only to those non-gift items.
		</td>
		</tr>
		</table>
		
		</td>
		</tr>
		</table>
		<p>
		];
	}
	
	
	if($GLOBAL_HAS_GIFTS==1){
		
		print qq[
		
		<table cellpadding="0" cellspacing="1" border="0" bgcolor="#000000">
		<tr>
		<td>
		
		<table cellpadding="5" cellspacing="0" border="0" class=warning>
		<tr>
		<td>
		<b>IMPORTANT</b> All of the items in your shopping cart are marked as gifts. Items will be shipped to the address associated with the recipient.
		</td>
		</tr>
		</table>
		
		</td>
		</tr>
		</table>
		<p>
		];
		}else{
		if($WEBDAT{'businessname2'} ne ""){
			print "$WEBDAT{'businessname2'}<BR>\n";
		}
		
		print "	$WEBDAT{'receiveby'}<BR>\n";
		print "		$WEBDAT{'street2'}<BR>\n";
		print "		$WEBDAT{'city2'}, $WEBDAT{'state2'}  $WEBDAT{'zip2'}<BR>\n";
		print "		$WEBDAT{'country2'}<BR>\n";
		print "		\n";
		print "		$WEBDAT{'phone2'}";
		
		
	}
	
	
	
	print "</TD></TR>\n";
	print "	\n";
	if($WEBDAT{'notes'} ne ""){
		print "	<TR class=\"smallheading\"><TD colspan=\"2\">SPECIAL NOTES:</TD></TR>\n";
		print "	<TR class=\"checkouttablebody\"><TD colspan=\"2\">$WEBDAT{'notes'}</TD></TR>\n";
	}
	if($gomodacc){
		print "<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">\n";
		
		
		if($WEBDAT{'ssl'}==1){
			print "	<FORM ACTION=\"$USERCONFIGS{'ssl_cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
			}else{
			print "	<FORM ACTION=\"$USERCONFIGS{'cgi_bin'}/cartit_checkout.cgi\" METHOD=\"POST\">\n";
		}
		print "<INPUT TYPE=\"HIDDEN\" NAME=\"ssl\" VALUE=\"$WEBDAT{'ssl'}\">\n";
		
		print "	<INPUT TYPE=\"HIDDEN\" NAME=\"command\" VALUE=\"manageit\">\n";
		print "	<INPUT TYPE=\"HIDDEN\" NAME=\"email\" VALUE=\"$WEBDAT{'email'}\">\n";
		print "	<INPUT TYPE=\"HIDDEN\" NAME=\"pass\" VALUE=\"$WEBDAT{'pass'}\">\n";
		print "<INPUT TYPE=\"hidden\" NAME=\"cid\" VALUE=\"$cart_ID\">\n";
		print "<INPUT TYPE=\"hidden\" NAME=\"doing_checkout_update\" VALUE=\"1\">\n";
		print "	\n";
		
		
		print "<INPUT TYPE=\"submit\" VALUE=\"Make Changes\"><p>";
		print "Please review the above information. If any of this information is not correct, please select the \"Make Changes\" button to update your account.\n";
		print "</FORM>	</TD></TR>\n";
		
	}
	
	
	
	
}


sub print_cc_input_section{
	my $stand_alone = shift;
	my(@CARDS);
	if(-e "$data_directory/cards.txt"){
		open(CARDS, "$data_directory/cards.txt") || die $!;
		@CARDS=(<CARDS>);
		close(CARDS);
		chomp(@CARDS);
	}
	
	
	
	
	
	
	print "<TR class=\"smallheading\"><TD COLSPAN=\"2\">\n";
	print "Credit Card Information:";
	print "</TD></TR>\n";
	print "	<TR class=\"checkouttablebody\"><TD COLSPAN=\"2\">\n";
	
	
	print "		<TABLE CELLPADDING=\"3\" CELLSPACING=\"0\" BORDER=\"0\" WIDTH=\"100%\" class=\"checkouttablebody\">\n";
	print "		<TR class=\"checkouttablebody\">\n";
	print "		<TD>\n";
	print "		<TABLE CELLPADDING=\"3\" CELLSPACING=\"0\" BORDER=\"0\" WIDTH=\"100%\">\n";
	print "		<TR class=\"checkouttablebody\">\n";
	print "$ERROR{'CC_TYPE'}\n";
	print "		<TD>Card Type</TD>\n";
	print "		<TD><SELECT NAME=\"ccname\">\n";
	my $SEL;
	foreach $card (@CARDS){
		$SEL =($card eq $WEBDAT{'ccname'}) ? ' SELECTED' : '';
		print "<OPTION VALUE=\"$card\"$SEL>$card\n";
	}
	
	
	
	print "		</SELECT></TD></TR>\n";
	print "		$ERROR{'CC_DATE'}\n";
	
	print "		<TR class=\"checkouttablebody\"><TD>Expiration Date</TD><TD>\n";
	print "		Month <SELECT NAME=\"ccmo\">\n";
	
	for ($i=1;$i<=12;$i++){
		$SEL =($i==$WEBDAT{'ccmo'}) ? ' SELECTED' : '';
		print sprintf("<OPTION VALUE=\"%02d\"%s>%02d",$i,$SEL,$i)
	}
	
	
	
	
	
	print "		</SELECT> \n";
	print "		Year <SELECT NAME=\"ccyr\">\n";
	my($nowyear) = &get_year;
	if($nowyear==99){
		print "<OPTION VALUE=\"99\">99\n";
		$nowyear = 0;
	}
	if($USERCUSTOM{'CCYR_STOPDIGIT'} < 30){
		for ($i=$nowyear;$i<=$USERCUSTOM{'CCYR_STOPDIGIT'};$i++){
			$SEL =($i==$WEBDAT{'ccyr'}) ? ' SELECTED' : '';
			print sprintf("<OPTION VALUE=\"%02d\"%s>%02d",$i,$SEL,$i)
		}
		
	}
	
	print "		</SELECT>\n";
	print "		</TD>\n";
	print "		</TR>\n";
	
	print "$ERROR{'CC_NUMBER'}\n";
	print "		<TR class=\"checkouttablebody\">\n";
	print "		<TD>Card Number</TD>\n";
	print "		<TD><INPUT TYPE=\"TEXT\" NAME=\"ccnum\" VALUE=\"$WEBDAT{'ccnum'}\" SIZE=\"20\" MAXLENGTH=\"25\"></TD>\n";
	print "		</TR>\n";
	
	if($USERCONFIGS{'ask_cvv'} && $USERCONFIGS{'cc_rtime'}){
		print '<TR class="smallheading">';
		print '<TD COLSPAN="2">Credit Card Verification</TD></TR>';
		print "$ERROR{'CC_CVV'}\n";
		print '<tr><td colspan="2">';
		print "\n<img src=\"$USERCUSTOM{'CVV_IMAGE_PATH'}\" width=\"127\" height=\"83\" alt=\"CVV\" border=\"0\" align=\"left\">\n" if($USERCUSTOM{'SHOW_CVV_IMAGE'});
		
		print qq[
		Please provide the Credit Card Verification number. These are the last three numbers on the back of your card just after your account number. If you are using an American Express, please provide the four digits on the right side of the card just above the card number.<br clear="all">
		];
		
		print 'Use the graphic for reference.'if($USERCUSTOM{'SHOW_CVV_IMAGE'});
		
		print '</td></tr>';
		print '<tr><td>Credit Card Verification</td><td><input type="text" name="cvv2" size="4" value="' . $WEBDAT{'cvv2'} . '"maxlength="4" id="cvv2"></td>';
		print '</tr>';
	}
	
	if($USERCONFIGS{'askccphone'}){
		print '<tr><td colspan="2">&nbsp;</td></tr>';
		print '<TR class="checkouttablebody">';
		print '<TD COLSPAN="2"><b>Bank Phone Number</b><br> If you look on the back of your credit card, you will find a phone number for the issuing bank.';
		print ' Please provide that number here; it can help us to expedite your order.</TD>';
		print '</TR>';
		print '<TR class="checkouttablebody">';
		print "<TD>Bank Number</TD>\n";
		print '<TD><INPUT TYPE="TEXT" NAME="ccphone" SIZE="20" MAXLENGTH="25"></TD>';
		print '</TR>';
		
	}
	
	
	
	print &get_file_as_iostring('checkout_cc_extend.html');
	
	
	
	
}



sub check_mods{
	my $x;
	foreach $x (keys %MODERROR){
		if($MODERROR{$x} == 1){
			return(1);
			last;
		}
	}
	return(0);
}



sub ModError_Header{
	print "Content-type: text/html\n\n";
	
	print qq[
	<html><head>
	<title>Module Errors</title>
	</head>
	<body bgcolor="#FFFFFF" text="#000000" link="#0000FF" vlink="#FF0000" alink="#808080">
	<div align="center"><table cellpadding="3" cellspacing="3" border="0" width="620">
	<tr>
	<td style="font-family:arial;size:10pt">
	
	<b>Errors Detected</b><br>
	CartIt has performed an evaluation of your configurations and the system CartIt is running on. Based on your configurations and the server system we have found the following errors.
	
	<p>
	<table width="615" cellpadding="4" cellspacing="0" border="1">
	<tr><td align="center" width="205"><b>Problem</b></td>
	<td align="center"  width="205"><b>Quick Solution</b></td>
	<td align="center" width="205"><b>Best Solution</b></td>
	</tr>
	
	
	];
	
}

sub ModError_Footer{
	
	print qq[
	</table>
	<p>
	<b>The following modules were not found and need to be installed.</b>
	<p>
	<hr size="1" align="LEFT" width="300">
	];
	
	
	foreach $x (keys %MODERROR){
		if($MODERROR{$x} == 1){
			print "<tt>$x</tt><br>"
		}
	}
	
	
	print qq[
	<hr size="1" align="LEFT" width="300">
	
	<p>
	
	Please note that these modules are business class modules and
	any Web presence provider offering business class Web hosting will
	have the ability to easily install these modules. If you do not
	have privileges to install these modules or if you do not know how this is done,
	please ask your Web presence provider to install these modules.
	<p>
	
	CartIt Corporation has no control over the server environment and therefore can not
	install or provide support for these modules.<p>
	
	
	</td>
	</tr>
	</table></div>
	
	</body>
	</html>
	];
	
	
}

