#!/usr/local/bin/perl
################################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################
$SVERSION{'commercebuddy.cgi'} = "8.0.07.377";
#All systems
$PASSFILE = '.pass';
if($^O eq 'MSWin32'){
$PASSFILE = 'my.pass';
	my $scriptname = $0;
	$scriptname =~ s/^(.*)[\/\\]([^\/\\]+)$/$2/;
	push(@INC,$1);
}

require ('cartitcf.cgi');
require ('cartitlib.cgi');



&about_cartit if($ENV{'QUERY_STRING'} eq "about");


$|=1;

if($ENV{'REQUEST_METHOD'} eq 'GET'){
	print "Content-type: text/html\n\n";
	print "HELLO!";
	exit;
}

#NEVER EDIT!
$ACCOUNTDEF = 30;
&parse_cmform;



&check_install(1)if($WEBDAT{'command'} eq 'check_install');
exit if(&check_pass);

	if($WEBDAT{'command'} eq 'genconfigs'){&genconfigs;
	}elsif($WEBDAT{'command'} eq 'get_new_stuff'){&get_new_stuff;
	}elsif($WEBDAT{'command'} eq 'clean_up_invoice'){&clean_up_invoice;
	}elsif($WEBDAT{'command'} eq 'get_new_accounts'){&get_new_accounts;
	}elsif($WEBDAT{'command'} eq 'data_int_fix_acct'){&data_int_fix_acct;
	}elsif($WEBDAT{'command'} eq 'emergency_unlock'){&emergency_unlock;
	}elsif($WEBDAT{'command'} eq 'check_data_integrity'){&check_data_integrity;
	}elsif($WEBDAT{'command'} eq 'poll_server'){&poll_server;
	}elsif($WEBDAT{'command'} eq 'changepass'){&changepass;
	}elsif($WEBDAT{'command'} eq 'lock_cartit'){&lock_cartit;
	
	
	}else{
	
	print_response('Invalid Command!');
	
}



#---------------------------------------------------------------------------------
sub parse_cmform{
	
	
	
	$cmtaxes = '';
	
	if ($ENV{'REQUEST_METHOD'} eq 'GET') {
		@pairs = split(/&/, $ENV{'QUERY_STRING'});
		
		}else{
		
		($ENV{'REQUEST_METHOD'} eq 'POST');
		if($ENV{'CONTENT_LENGTH'}>50000){&system_error('spam');}
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
		
		@pairs = split(/&/, $buffer);
	}
	
	foreach $pair (@pairs) {
		local($name, $value) = split(/=/, $pair);
		$name =~ tr/+/ /;
		$name =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ge;
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ge;
		$value=~ s/^\s+//g;
		&ripcm($name,$value);
		
	}
}


sub ripcm{
	my($name,$value) = @_;
	if($name eq "taxstring"){
		$value =~ s!\^!\|!g;
		@taxes = split(/:TAX:/,$value);
		
		}elsif($name eq "currencyconversion"){
		$value =~ s!\^!\|!g;
		@currencyconversion = split(/:CURCON:/,$value);
		
		}elsif($name eq "shipitstring"){
		$value =~ s!\^!\|!g;
		@shipit = split(/:SHIPIT:/,$value);
		
		
		}elsif($name eq "couponsstring"){
		$value =~ s!\^!\|!g;
		@coupons = split(/:COUPON:/,$value);
		
		}elsif($name eq "gifts_data"){
		$value =~ s!\^!\|!g;
		@gifts = split(/:GIFT:/,$value);
		
		}elsif($name eq "shipitextstring"){
		$value =~ s!\^!\|!g;
		@shipitexts = split(/:NEXTSHIPITEXT:/,$value);
		
		}elsif($name eq "smarttaxstring"){
		$value =~ s!\^!\|!g;
		@smarttaxes = split(/:SMARTTAXITEM:/,$value);
		
		
		}elsif($name eq "mailfix"){
		@fix_mail_acct = split(/\|/,$value);
		
		
		
		
		}elsif($name =~/CONFIG_/){
		$name =~ s!^CONFIG_!!g;
		$USERCONFIGS{$name}=$value;
		}elsif($name eq "cccard"){
		push(@cccards,$value);
		}else{
		$WEBDAT{$name} = $value;
	}
}


#---------------------------------------------------------------------------------
sub genconfigs{
	$RESPONSE ='Configuration file updated!';
	open (FILE, ">$data_directory/config") ||  &fatal_error_out("Failed to open: $data_directory/config");
	foreach $config (sort keys %USERCONFIGS){
		print FILE "$config\|$USERCONFIGS{$config}\n";
	}
	close(FILE);
	
	if(@cccards){
		
		open (FILE, ">$data_directory/cards.txt") ||  &fatal_error_out("Failed to open: $data_directory/cards.txt");
		foreach $cc (@cccards){
			print FILE "$cc\n";
		}
		close(FILE);
		
	}
	
	open (FILE, ">$data_directory/taxes.txt") ||  &fatal_error_out("Failed to open: $data_directory/taxes.txt");
	$size = @taxes;
	foreach $tax (@taxes){
		print FILE "$tax\n";
	}
	close(FILE);
	
	if($size){
		$RESPONSE .= "::$size taxes added or updated";
		}else{
		$RESPONSE .= "::taxes record count is now 0";
	}
	
	
	
	open (FILE, ">$data_directory/currency.txt") ||  &fatal_error_out("Failed to open: $data_directory/currency.txt");
	$size = @currencyconversion;
	foreach $cccon (@currencyconversion){
		print FILE "$cccon\n";
	}
	close(FILE);
	
	if($size){
		$RESPONSE .= "::$size currency conversion records added or updated";
		}else{
		$RESPONSE .= "::currency conversion record count is now 0";
	}
	
	
	
	
	
	
	
	
	
	open (FILE, ">$data_directory/smarttaxes.txt") || &fatal_error_out("Failed to open: $data_directory/smarttaxes.txt");
	$size = @smarttaxes;
	foreach $cou (@smarttaxes){
		print FILE "$cou\n";
	}
	close(FILE);
	
	if($size){
		$RESPONSE .= "::$size smart taxes added or updated";
		}else{
		$RESPONSE .= "::smart taxes record count is now 0";
	}
	
	open (FILE, ">$data_directory/shipit.dat") || &fatal_error_out("Failed to open: $data_directory/shipit.dat");
	$size = @shipit;
	foreach $ship (@shipit){
		print FILE "$ship\n";
	}
	close(FILE);
	if($size){
		$RESPONSE .= "::$size weights and fees added or updated";
		}else{
		$RESPONSE .= "::weights and fees record count is now 0";
	}
	
	
	
	
	
	
	
	
	
	open (FILE, ">$data_directory/shipext.txt") || &fatal_error_out("Failed to open: $data_directory/shipext.txt");
	$size = @shipitexts;
	foreach $cou (@shipitexts){
		print FILE "$cou\n";
	}
	close(FILE);
	
	if($size){
		$RESPONSE .= "::$size shipping weight extensions added or updated";
		}else{
		$RESPONSE .= "::shipping weight extensions record count is now 0";
	}
	
	
	
	
	
	if($USERCUSTOM{'GIFT_MOD_LOADED'}){
		
		open(FILE, ">$data_directory/giftwrap.txt") ||  &fatal_error_out("Failed to open: $data_directory/giftwrap.txt");
		$size = @gifts;
		foreach $g (@gifts){
			print FILE "$g\n";
		}
		close(FILE);
		
		if($size){
			$RESPONSE .= "::$size gift records added or updated";
			}else{
			$RESPONSE .= "::gift record count is now 0";
		}
	}
	
	
	open (FILE, ">$data_directory/coupons.txt") ||  &fatal_error_out("Failed to open: $data_directory/coupons.txt");
	$size =@coupons;
	foreach $cou (@coupons){
		print FILE "$cou\n";
	}
	close(FILE);
	if($size){
		$RESPONSE .= "::$size coupons added or updated";
		}else{
		$RESPONSE .= "::coupons record count is now 0";
	}
	
	
	print_response($RESPONSE);
	
}



sub print_response{
	my($RESPONSE) = shift;
	print "Content-type: text/html\n\n" if(!$HEADER_PRINTED);
	print "CartItResponse: Hello $ENV{'HTTP_USER_AGENT'}:: $RESPONSE\n\n\n\n";
	$HEADER_PRINTED = 1;
}

sub print_action{
	my($RESPONSE) = shift;
	print "Content-type: text/html\n\n" if(!$HEADER_PRINTED);
	print "CartItAction: $RESPONSE\n\n\n\n";
	$HEADER_PRINTED = 1;
}

#---------------------------------------------------------------------------------
sub get_new_stuff{
	
	
	
	print "Content-type: text/html\n\n" ;
	$HEADER_PRINTED = 1;
	
	
	if(-s "$data_directory/neworder.txt"){
		print 'STARTCartItResponse|Orders:';
		open (FILE, "$data_directory/neworder.txt") || return(0);
		while(<FILE>){
			print $_;
		}
		close(FILE);
		print 'ENDCartItResponse|Orders:';
		
		print "\n\n\n\n";
		
		print 'STARTCartItResponse|HTML:';
		open (FILE, "$data_directory/neworder.dat") || return(0);
		while(<FILE>){
			chomp($_);
			print $_;
		}
		close(FILE);
		print 'ENDCartItResponse|HTML:';
		
		print "\n\n\n\n";
	}
	
	if(-s "$data_directory/account.new"){
		print 'STARTCartItResponse|Accounts:';
		open (FILE, "$data_directory/account.new") || return(0);
		while(<FILE>){
			print $_;
		}
		close(FILE);
		print 'ENDCartItResponse|Accounts:';
		
		print "\n\n\n\n";
	}
	
	
	
	if(-s "$data_directory/notes.api"){
		print 'STARTCartItResponse|Notes:';
		open (FILE, "$data_directory/notes.api") || return(0);
		while(<FILE>){
			print $_;
		}
		close(FILE);
		print 'ENDCartItResponse|Notes:';
		
		print "\n\n\n\n";
	}
	
	if(-s "$data_directory/invoice_markers.dat"){
		print 'STARTCartItResponse|InvMarks:';
		open (FILE, "$data_directory/invoice_markers.dat") || return(0);
		while(<FILE>){
			print $_;
		}
		close(FILE);
		print 'ENDCartItResponse|InvMarks:';
		
		print "\n\n\n\n";
	}
	
	if(-s "$data_directory/invoice_status.dat"){
		print 'STARTCartItResponse|InvoiceStatus:';
		open (FILE, "$data_directory/invoice_status.dat") || return(0);
		while(<FILE>){
			print $_;
		}
		close(FILE);
		print 'ENDCartItResponse|InvoiceStatus:';
		
		print "\n\n\n\n";
	}
	
	
	
	
	
	
	print "CartItResponse:Records Downloaded\n\n\n\n";
	print_action("DataSuccess");
	
	exit;
}

#---------------------------------------------------------------------------------
sub clean_up_invoice{
	open (FILE, ">$data_directory/neworder.dat") || return(0);
	close(FILE);
	open (FILE, ">$data_directory/neworder.txt") || return(0);
	close(FILE);
	open (FILE, ">$data_directory/notes.api") || return(0);
	close(FILE);
	open (FILE, ">$data_directory/invoice_markers.dat") || return(0);
	close(FILE);
	open (FILE, ">$data_directory/invoice_status.dat") || return(0);
	close(FILE);


	&account_storage;
	if(&manager_unlock){
		print_response('Site cleaned up and unlocked.');
		print_action("UNLOCKED!");
		}else{
		print_response('Failed to unlock site!');
		print_action("SITELOCKNOTICE");
		
	}
	exit;
	
}

#---------------------------------------------------------------------------------
sub manager_unlock{
	unlink("$data_directory/manager.lock")if(-e "$data_directory/manager.lock");
	return(0)if(-e "$data_directory/manager.lock");
	return(1);
	
}

#---------------------------------------------------------------------------------
sub manager_file_lock{
	my($i) = 0;
	if(!-e "$data_directory/manager.lock"){
		open(FLOCK,">$data_directory/manager.lock");
		print FLOCK "1";
		close(FLOCK);
		return();
	}
	
	
	while(-e "$data_directory/manager.lock" && $i<=3){
		sleep(1);
		$i++;
	}
	
	if(!-e "$data_directory/manager.lock"){
		open(FLOCK,">$data_directory/manager.lock");
		print FLOCK "1";
		close(FLOCK);
		return(1);
		}else{
		print_response("Site is locked. You may need to do an emergency unlock!");
		print_action("LOCKERROR");
		exit;
		
	}
}

sub emergency_unlock{
	if(!-e "$data_directory/manager.lock"){
		&print_response("Site is not locked - No need to perform this action!");
		&print_action("NOLOCKSTOP");
		exit;
	}
	
	unlink("$data_directory/manager.lock")if(-e "$data_directory/manager.lock");
	if(-e "$data_directory/manager.lock"){
		&print_response("I could not unlock the site! You may have to delete the manager.lock file in the data directory::It seems that I do not have permission to do this myself!");
		&print_action("MANUALUNLOCK");
		exit;
	}
	&print_response("Unlock seems to have worked!");
	&print_action('WASUNLOCK');
	exit;
}

sub poll_server{
	$RESPONSE = "";
	
	
	if(-e "$data_directory/manager.lock"){
		$RESPONSE .= "The site is locked when it should not be. You may need to do an emergency unlock!";
		}else{
		$RESPONSE .= "No site lock.";
	}
	
	if(-s "$data_directory/neworder.txt"){
		$RESPONSE .= "::It appears that you have new orders.";
		}else{
		$RESPONSE .= "::No New Orders";
	}
	
	
	if(-s "$data_directory/account.new"){
		$RESPONSE .= "::It appears that you have new accounts.";
		}else{
		$RESPONSE .= "::No New Accounts";
	}
	
	if(-s "$data_directory/notes.api"){
		$RESPONSE .= "::It appears that you have new notes from API calls";
		}else{
		$RESPONSE .= "::No New Notes";
	}

	if(-s "$data_directory/invoice_markers.dat"){
		$RESPONSE .= "::It appears that you have new Order markers.";
		}else{
		$RESPONSE .= "::No Order markers";
	}

	if(-s "$data_directory/invoice_status.dat"){
		$RESPONSE .= "::It appears that you have new order status records.";
		}else{
		$RESPONSE .= "::No Order Status Records";
	}

	
	
	print_response("$RESPONSE");
	
}


sub fatal_error_out{
	$error_code = shift;
	&print_response("CartIt experienced a fatal error: The Status Code is: \"$error_code\"");
	
}
#Note from ed: Rather long code, make it faster/cleaner
sub check_data_integrity{
	my($databad ,$invoice,$account,$pass,$email,$rest,$remoteinvoice,$MRETSTRING, $RESPONSE);
	$MRETSTRING = '';
	my %invthash,%acchash;
	
	
	$nonewdata = 0;
	&manager_file_lock;
		if((!-e "$data_directory/neworder.txt")||
		(!-e "$data_directory/neworder.dat")||
		(!-e "$data_directory/account.new")){
		&manager_unlock;
		print_response("One or more of three important files are missing from your data directory.::neworder.txt::neworder.dat::account.new");
		exit;
	}
	
	
		if((-z "$data_directory/neworder.txt")&&
		(-z "$data_directory/neworder.dat")&&
		(-z "$data_directory/account.new")){
		$nonewdata = 1;
	}
	
	if(-e "$data_directory/notes.api"){
		if (-s "$data_directory/notes.api"){
			$nonewdata = 0;
		}
	}

	if(-e "$data_directory/invoice_markers.dat"){
		if (-s "$data_directory/invoice_markers.dat"){
			$nonewdata = 0;
		}
	}

	if(-e "$data_directory/invoice_status.dat"){
		if (-s "$data_directory/invoice_status.dat"){
			$nonewdata = 0;
		}
	}
	
	
	
	if($nonewdata){
		&manager_unlock;
		print_response('No new items!');
		print_action("NO_NEED");
		exit;
	}
	
	
	
	
	
	
	open (FILE, "$data_directory/account.new");
	my(@LINES) = (<FILE>);
	close(FILE);
	chomp(@LINES);
	open (FILE, ">$data_directory/account.new");
	for($i=0;$i<@LINES;$i++){
		@TOADD = split(/\|/,$LINES[$i]);
		if(!$acchash{$TOADD[2]}){
			for($j=0;$j<$ACCOUNTDEF;$j++){
				print FILE "$TOADD[$j]";
				print FILE "|" if($j<$ACCOUNTDEF);
			}
			print FILE "\n";
			}else{
			$databad = 1;
		}
		$acchash{$TOADD[2]} =$TOADD[0];
		
	}
	close(FILE);
	
	
	
	
	undef(%acchash);
	
	open (FILE, "$data_directory/account.new");
	my(@LINES) = (<FILE>);
	close(FILE);
	chomp(@LINES);
	for($i=0;$i<@LINES;$i++){
		$MRETSTRING .= "$TOADD[0]\^$TOADD[2]\|";
		@TOADD = split(/\|/,$LINES[$i]);
		$acchash{$TOADD[2]} =$TOADD[0];
	}
	
	
	
	
	
	open (FILE, "$data_directory/neworder.txt");
	my(@LINES) = (<FILE>);
	close(FILE);
	chomp(@LINES);
	open (FILE, ">$data_directory/neworder.txt");
	for($i=0;$i<@LINES;$i++){
		@TOADD = split(/\|/,$LINES[$i]);
		if($acchash{$TOADD[3]}){
			$TOADD[1] = $acchash{$TOADD[3]};
		}
		
		for($j=0;$j<@TOADD;$j++){
			print FILE "$TOADD[$j]";
			print FILE "|" if(($j+1)<@TOADD);
			
		}
		print FILE "\n";
	}
	
	
	close(FILE);
	
	
	
	
	
	
	
	if($databad){
		$RESPONSE .= 'Duplicate account records found and corrected!'
		
	}
	
	
	
	$databad = 0;
	
	
	
	open (FILE, "$data_directory/neworder.txt");
	my(@LINES) = (<FILE>);
	close(FILE);
	for($i=0;$i<@LINES;$i++){
		($invoice,$account,$pass,$email,$rest) = split(/\|/,$LINES[$i]);
		
		
		if(($invthash{$invoice}) || ($invoice<=$WEBDAT{'hinv'})){
			$databad = 1;
		}
		
		$invthash{$invoice} = 1;
		
		
	}
	
	
	if($databad){
		$RESPONSE .='::Data integrity errors found!';
		
		$remoteinvoice = $WEBDAT{'hinv'};
		open (FILE, "$data_directory/neworder.txt");
		my(@LINES) = (<FILE>);
		chomp(@LINES);
		close(FILE);
		open (FILE, ">$data_directory/neworder.txt");
		for($i=0;$i<@LINES;$i++){
			@TOADD = split(/\|/,$LINES[$i]);
			$remoteinvoice++;
			print FILE "$remoteinvoice\|";
			for($j=0;$j<@TOADD;$j++){
				if($j>0){
					print FILE "$TOADD[$j]";
					print FILE "|" if(($j+1)<@TOADD);
					
				}
				
				
			}
			print FILE "\n";
		}
		
		close(FILE);
		
		
		open (FILE, ">$data_directory/invoices.count");
		print FILE "$remoteinvoice";
		close(FILE);
		
		
		$remoteinvoice2 = $WEBDAT{'hinv'};
		open (FILE, "$data_directory/neworder.dat");
		my(@LINES) = (<FILE>);
		close(FILE);
		open (FILE, ">$data_directory/neworder.dat");
		for($i=0;$i<@LINES;$i++){
			if($LINES[$i] =~/CartItBeginInvoice\|(\d+)<!--END-->/){
				
				$remoteinvoice2++;
				$LINES[$i]=~ s/(CartItBeginInvoice\|)(\d+)(<!--END-->)/$1$remoteinvoice2$3/g;
			}
			$LINES[$i]=~s/(CartItEndInvoice\|)(\d+)/$1$remoteinvoice2/g;
			
			if($remoteinvoice2<=$remoteinvoice){
				print FILE "$LINES[$i]";
			}
			
			
			
			
		}
		
		
		$RESPONSE .= '::Duplicate or bad invoices found and corrected!';
		$RESPONSE .= '::E-mail may not match new corrected invoices';
		
	}
	&print_response($RESPONSE);
	print "\n\n\n\n\n\n";
	print "DATAINTSTARTCartItResponse|$MRETSTRING|DATAINTENDCartItResponse";
	exit;
	
}
#Note from ed: Rather long code, make it faster/cleaner
sub data_int_fix_acct{
	
	
	if(@fix_mail_acct){
		foreach $rec (@fix_mail_acct){
			@dsplic = split(/::/,$rec);
			if($dsplic[0] ne "" && $dsplic[1] ne ""){
				$COMMERCEBUDDYHASH{uc($dsplic[0])} = $dsplic[1];
			}
		}
		
	}
	
	
	
	open (FILE, "$data_directory/neworder.txt");
	my(@OLINES) = (<FILE>);
	chomp(@OLINES);
	close(FILE);
	open (FILE, ">$data_directory/neworder.txt");
	for($i=0;$i<@OLINES;$i++){
		next if($OLINES[$i] eq '');
		@TOADD = split(/\|/,$OLINES[$i]);
		
		if($COMMERCEBUDDYHASH{$TOADD[3]}){
			$TOADD[1] = $COMMERCEBUDDYHASH{$TOADD[3]};
			
		}
		
		for($j=0;$j<@TOADD;$j++){
			print FILE "$TOADD[$j]";
			print FILE "|" if(($j+1)<@TOADD);
		}
		
		print FILE "\n";
	}
	
	close(FILE);
	
	
	
	open (FILE, "$data_directory/account.new");
	my(@ALINES) = (<FILE>);
	chomp(@ALINES);
	close(FILE);
	open (FILE, ">$data_directory/account.new");
	for($i=0;$i<@ALINES;$i++){
		next if($ALINES[$i] eq '');
		@TOADD = split(/\|/,$ALINES[$i]);
		
		if($COMMERCEBUDDYHASH{$TOADD[2]}){
			$TOADD[0] = $COMMERCEBUDDYHASH{$TOADD[2]};
			
			}else{
			
			$NOTSYNC{$TOADD[2]}++;
			$NOTSYNC2{$TOADD[0]}++;
			$DUPERR = 1 if($NOTSYNC2{$TOADD[0]}>1);
			if($TOADD[0] < $WEBDAT{'hacc'}){
				$DUPERR = 1;
				
			}
			
		}
		
		$highaccount = $TOADD[0] if($TOADD[0]>$highaccount);
		
		for($j=0;$j<$ACCOUNTDEF;$j++){
			print FILE "$TOADD[$j]";
			print FILE "|" if($j<$ACCOUNTDEF);
			
		}
		print FILE "\n";
	}
	
	close(FILE);
	
	
	
	
	
	if($DUPERR){
		$highaccount = $WEBDAT{'hacc'} if($WEBDAT{'hacc'}>$highaccount);
		open (FILE, "$data_directory/account.new");
		my(@ALINES) = (<FILE>);
		chomp(@ALINES);
		close(FILE);
		open (FILE, ">$data_directory/account.new");
		for($i=0;$i<@ALINES;$i++){
			next if($ALINES[$i] eq '');
			@TOADD = split(/\|/,$ALINES[$i]);
			if($NOTSYNC{$TOADD[2]}){
				
				$TOADD[0] = ++$highaccount;
				$NOTSYNC{$TOADD[2]} = $highaccount;
			}
			
			for($j=0;$j<@TOADD;$j++){
				print FILE "$TOADD[$j]";
				print FILE "|" if($j<$ACCOUNTDEF);
				
			}
			
			print FILE "\n";
		}
		
		
		
		close(FILE);
		
		
		
		open (FILE, "$data_directory/neworder.txt");
		my(@OLINES) = (<FILE>);
		chomp(@OLINES);
		close(FILE);
		open (FILE, ">$data_directory/neworder.txt");
		for($i=0;$i<@OLINES;$i++){
			next if($OLINES[$i] eq '');
			@TOADD = split(/\|/,$OLINES[$i]);
			
			if($NOTSYNC{$TOADD[3]}){
				$TOADD[1] = $NOTSYNC{$TOADD[3]};
			}
			for($j=0;$j<@TOADD;$j++){
				print FILE "$TOADD[$j]";
				print FILE "|" if(($j+1)<@TOADD);
			}
			
			print FILE "\n";
		}
		
		close(FILE);
		
		open (FILE, ">$data_directory/accounts.count");
		print FILE "$highaccount";
		close(FILE);
		
		
	}
	
	&print_response("Account integrity correction complete.");
	
}

#---------------------------------------------------------------------------------
sub account_storage{
	return(0)if(!-e "$data_directory/account.new");
	return(1)if(-z "$data_directory/account.new");
	open(FILE, "$data_directory/account.new") || return(0);
	@all_accounts = (<FILE>);
	close(FILE);
	chomp(@all_accounts);
	
	foreach $acc (@all_accounts){
		$account_char ='';
		@MYA = split(/\|/,$acc);
		$account_char = &get_fileid_ofacount($MYA[2]);
		$account_char .= "." . "accounts";
		
		if(!-e "$data_directory/$account_char"){
			open(FILE, ">$data_directory/$account_char") || return(0);
			close(FILE);
			chmod(0777, "$data_directory/$account_char");
			
		}
		
		open(FILE, ">>$data_directory/$account_char") || return(0);
		print FILE "$acc\n";
		close(FILE);
		
		
	}
	
	open(FILE, ">$data_directory/account.new") || return(0);
	close(FILE);
	
	return(1);
	
}


#---------------------------------------------------------------------------------
sub check_install{
	&print_response('Check install is not available in this version of CommerceBuddy.');
	exit;
}
#---------------------------------------------------------------------------------
sub changepass{
	$firstuse = shift;
	
	if($firstuse){
		$WEBDAT{'newpass'} = 'cartit'
		}else{
		if (length $WEBDAT{'newpass'} < 5){
			&print_response('Password must be at least 5 characters.');
			exit;
		}
		
		
		if ($WEBDAT{'newpass'} =~ /\W/){
			&print_response('Password must be letters and numbers only.');
			exit;
		}
		open(PASSWD,"$data_directory/$PASSFILE") || &fatal_error_out('Can not open password file!');
		$truepass = <PASSWD>;
		close(PASSWD);
		chop($truepass) if $truepass =~ /\n$/;
		
	}
	
	$np = crypt($WEBDAT{'newpass'},substr($truepass , 0, 2));
	open(PASSWD,">$data_directory/$PASSFILE") ||&fatal_error_out('Can not open/create password file.');
	print PASSWD "$np";
	close(PASSWD);
	
	if($firstuse){
		&print_response('Everything is OK!::Password file created!::Your password is now "cartit" and you can change this password at any time!');
		&print_action("OK");
		}else{
		&print_response('Your password has been changed!');
		&print_action("PASSCHANGED");
		
	}
	
	exit;
	
	
}
#---------------------------------------------------------------------------------
sub check_pass{
	if($WEBDAT{'crypt_keeper'} eq ""){
		&print_response('No password was provided!');
		&print_action("PASS_INVALID");
		return(1);
	}
	
	open(PASSWD,"$data_directory/$PASSFILE") || &fatal_error_out('Can not open password file!');
	$truepass = <PASSWD>;
	close(PASSWD);
	chop($truepass) if $truepass =~ /\n$/;
	$userpass = crypt($WEBDAT{'crypt_keeper'}, substr($truepass, 0, 2));
	if($userpass ne "$truepass"){
		&print_response('Password was not valid!');
		&print_action("PASS_INVALID");
		return(1);
	}
	
	
	if(!-d "$data_directory"){
		&print_response("The data directory ($data_directory) as you configured it in cartitcf.cgi is invalid!");
		return(1);
	}
	
	if(!-d "$cart_directory"){
		&print_response("The carts directory ($cart_directory) as you configured it in cartitcf.cgi is invalid!");
		return(1);
		
	}
	
	return(0);
	
}

#---------------------------------------------------------------------------------
sub lock_cartit{
	open(FLOCK,">$data_directory/manager.lock");
	print FLOCK "1";
	close(FLOCK);
	print_response("CartIt is now locked!");
	exit;
}


